# coding: utf-8

"""
    (C) Copyright 2018-2019 Hewlett Packard Enterprise Development LP

    Hardware Monitoring

    unused  # noqa: E501

    Component version: 3.17-SNAPSHOT
"""


import pprint
import re  # noqa: F401

import six


class ServerComponentModel(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'status': 'str',
        'health_status_map': 'str',
        'uuid': 'str',
        'name': 'str',
        'model': 'str',
        'serial_number': 'str'
    }

    attribute_map = {
        'status': 'status',
        'health_status_map': 'healthStatusMap',
        'uuid': 'uuid',
        'name': 'name',
        'model': 'model',
        'serial_number': 'serialNumber'
    }

    def __init__(self, status=None, health_status_map=None, uuid=None, name=None, model=None, serial_number=None):  # noqa: E501
        """ServerComponentModel - a model defined in Swagger"""  # noqa: E501

        self._status = None
        self._health_status_map = None
        self._uuid = None
        self._name = None
        self._model = None
        self._serial_number = None
        self.discriminator = None

        if status is not None:
            self.status = status
        if health_status_map is not None:
            self.health_status_map = health_status_map
        if uuid is not None:
            self.uuid = uuid
        if name is not None:
            self.name = name
        if model is not None:
            self.model = model
        if serial_number is not None:
            self.serial_number = serial_number

    @property
    def status(self):
        """Gets the status of this ServerComponentModel.  # noqa: E501


        :return: The status of this ServerComponentModel.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this ServerComponentModel.


        :param status: The status of this ServerComponentModel.  # noqa: E501
        :type: str
        """
        allowed_values = ["UNUSED", "OK", "OFFLINE", "UNAUTHORIZED", "DEGRADED", "FAILED", "UNKNOWN", "MISSING"]  # noqa: E501
        if status not in allowed_values:
            raise ValueError(
                "Invalid value for `status` ({0}), must be one of {1}"  # noqa: E501
                .format(status, allowed_values)
            )

        self._status = status

    @property
    def health_status_map(self):
        """Gets the health_status_map of this ServerComponentModel.  # noqa: E501


        :return: The health_status_map of this ServerComponentModel.  # noqa: E501
        :rtype: str
        """
        return self._health_status_map

    @health_status_map.setter
    def health_status_map(self, health_status_map):
        """Sets the health_status_map of this ServerComponentModel.


        :param health_status_map: The health_status_map of this ServerComponentModel.  # noqa: E501
        :type: str
        """
        allowed_values = ["Critical", "Warning", "OK", "Unknown", "Disabled"]  # noqa: E501
        if health_status_map not in allowed_values:
            raise ValueError(
                "Invalid value for `health_status_map` ({0}), must be one of {1}"  # noqa: E501
                .format(health_status_map, allowed_values)
            )

        self._health_status_map = health_status_map

    @property
    def uuid(self):
        """Gets the uuid of this ServerComponentModel.  # noqa: E501


        :return: The uuid of this ServerComponentModel.  # noqa: E501
        :rtype: str
        """
        return self._uuid

    @uuid.setter
    def uuid(self, uuid):
        """Sets the uuid of this ServerComponentModel.


        :param uuid: The uuid of this ServerComponentModel.  # noqa: E501
        :type: str
        """

        self._uuid = uuid

    @property
    def name(self):
        """Gets the name of this ServerComponentModel.  # noqa: E501


        :return: The name of this ServerComponentModel.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ServerComponentModel.


        :param name: The name of this ServerComponentModel.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def model(self):
        """Gets the model of this ServerComponentModel.  # noqa: E501


        :return: The model of this ServerComponentModel.  # noqa: E501
        :rtype: str
        """
        return self._model

    @model.setter
    def model(self, model):
        """Sets the model of this ServerComponentModel.


        :param model: The model of this ServerComponentModel.  # noqa: E501
        :type: str
        """

        self._model = model

    @property
    def serial_number(self):
        """Gets the serial_number of this ServerComponentModel.  # noqa: E501


        :return: The serial_number of this ServerComponentModel.  # noqa: E501
        :rtype: str
        """
        return self._serial_number

    @serial_number.setter
    def serial_number(self, serial_number):
        """Sets the serial_number of this ServerComponentModel.


        :param serial_number: The serial_number of this ServerComponentModel.  # noqa: E501
        :type: str
        """

        self._serial_number = serial_number

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ServerComponentModel, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ServerComponentModel):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
