# coding: utf-8

"""
    (C) Copyright 2018-2019 Hewlett Packard Enterprise Development LP

    Catalyst

    unused  # noqa: E501

    Component version: 10.3.15-SNAPSHOT
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from ..api_client import ApiClient


class CloudParametricsApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_cloud_parametrics_reports(self, **kwargs):  # noqa: E501
        """Get a catalyst cloud metric reports  # noqa: E501

        Returns a stores reports between the start and end dates, samples denotes  the amount of members to return  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_cloud_parametrics_reports(async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param datetime start_date: The date from which samples should be returned.
        :param datetime end_date: The date samples should be returned up until
        :param str samples: The maximum number of samples to return.
        :return: CloudParametricsCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.get_cloud_parametrics_reports_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_cloud_parametrics_reports_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_cloud_parametrics_reports_with_http_info(self, **kwargs):  # noqa: E501
        """Get a catalyst cloud metric reports  # noqa: E501

        Returns a stores reports between the start and end dates, samples denotes  the amount of members to return  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.get_cloud_parametrics_reports_with_http_info(async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param datetime start_date: The date from which samples should be returned.
        :param datetime end_date: The date samples should be returned up until
        :param str samples: The maximum number of samples to return.
        :return: CloudParametricsCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['start_date', 'end_date', 'samples']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_cloud_parametrics_reports" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'start_date' in params:
            query_params.append(('startDate', params['start_date']))  # noqa: E501
        if 'end_date' in params:
            query_params.append(('endDate', params['end_date']))  # noqa: E501
        if 'samples' in params:
            query_params.append(('samples', params['samples']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/cat/parametrics-cloud', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='CloudParametricsCollection',  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_cloud_store_parametrics_reports(self, storeid, **kwargs):  # noqa: E501
        """Get catalyst cloud store parametric reports  # noqa: E501

        Returns store reports between the start and end dates, samples denotes the amount of members to return  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_cloud_store_parametrics_reports(storeid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str storeid: ID of the Catalyst store (required)
        :param datetime start_date: The date from which samples should be returned.
        :param datetime end_date: The date samples should be returned up until
        :param str samples: The maximum number of samples to return.
        :param str include_historical: Boolean to specify if metrics returned are exclusively for the current store 
        :return: CloudParametricsCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.get_cloud_store_parametrics_reports_with_http_info(storeid, **kwargs)  # noqa: E501
        else:
            (data) = self.get_cloud_store_parametrics_reports_with_http_info(storeid, **kwargs)  # noqa: E501
            return data

    def get_cloud_store_parametrics_reports_with_http_info(self, storeid, **kwargs):  # noqa: E501
        """Get catalyst cloud store parametric reports  # noqa: E501

        Returns store reports between the start and end dates, samples denotes the amount of members to return  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.get_cloud_store_parametrics_reports_with_http_info(storeid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str storeid: ID of the Catalyst store (required)
        :param datetime start_date: The date from which samples should be returned.
        :param datetime end_date: The date samples should be returned up until
        :param str samples: The maximum number of samples to return.
        :param str include_historical: Boolean to specify if metrics returned are exclusively for the current store 
        :return: CloudParametricsCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['storeid', 'start_date', 'end_date', 'samples', 'include_historical']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_cloud_store_parametrics_reports" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'storeid' is set
        if ('storeid' not in params or
                params['storeid'] is None):
            raise ValueError("Missing the required parameter `storeid` when calling `get_cloud_store_parametrics_reports`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'storeid' in params:
            path_params['storeid'] = params['storeid']  # noqa: E501

        query_params = []
        if 'start_date' in params:
            query_params.append(('startDate', params['start_date']))  # noqa: E501
        if 'end_date' in params:
            query_params.append(('endDate', params['end_date']))  # noqa: E501
        if 'samples' in params:
            query_params.append(('samples', params['samples']))  # noqa: E501
        if 'include_historical' in params:
            query_params.append(('includeHistorical', params['include_historical']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/cat/parametrics-cloud/store/{storeid}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='CloudParametricsCollection',  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
