# coding: utf-8

"""
    (C) Copyright 2018-2019 Hewlett Packard Enterprise Development LP

    Catalyst

    unused  # noqa: E501

    Component version: 10.3.15-SNAPSHOT
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from ..api_client import ApiClient


class CloudDiagnosticsApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_cloud_diagnostic(self, storeid, diagnosticid, **kwargs):  # noqa: E501
        """Get results from a specific diagnostic run  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_cloud_diagnostic(storeid, diagnosticid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str storeid: ID of the Catalyst store (required)
        :param str diagnosticid: ID of the cloud diagnostics (required)
        :return: CloudStoreDiagnostics
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.get_cloud_diagnostic_with_http_info(storeid, diagnosticid, **kwargs)  # noqa: E501
        else:
            (data) = self.get_cloud_diagnostic_with_http_info(storeid, diagnosticid, **kwargs)  # noqa: E501
            return data

    def get_cloud_diagnostic_with_http_info(self, storeid, diagnosticid, **kwargs):  # noqa: E501
        """Get results from a specific diagnostic run  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.get_cloud_diagnostic_with_http_info(storeid, diagnosticid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str storeid: ID of the Catalyst store (required)
        :param str diagnosticid: ID of the cloud diagnostics (required)
        :return: CloudStoreDiagnostics
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['storeid', 'diagnosticid']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_cloud_diagnostic" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'storeid' is set
        if ('storeid' not in params or
                params['storeid'] is None):
            raise ValueError("Missing the required parameter `storeid` when calling `get_cloud_diagnostic`")  # noqa: E501
        # verify the required parameter 'diagnosticid' is set
        if ('diagnosticid' not in params or
                params['diagnosticid'] is None):
            raise ValueError("Missing the required parameter `diagnosticid` when calling `get_cloud_diagnostic`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'storeid' in params:
            path_params['storeid'] = params['storeid']  # noqa: E501
        if 'diagnosticid' in params:
            path_params['diagnosticid'] = params['diagnosticid']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/cat/cloud-store-diagnostics/store/{storeid}/diagnostics/{diagnosticid}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='CloudStoreDiagnostics',  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_cloud_diagnostics(self, storeid, **kwargs):  # noqa: E501
        """Get all previous diagnostic results for the given store.  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_cloud_diagnostics(storeid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str storeid: ID of the Catalyst store (required)
        :return: CloudStoreDiagnosticsCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.get_cloud_diagnostics_with_http_info(storeid, **kwargs)  # noqa: E501
        else:
            (data) = self.get_cloud_diagnostics_with_http_info(storeid, **kwargs)  # noqa: E501
            return data

    def get_cloud_diagnostics_with_http_info(self, storeid, **kwargs):  # noqa: E501
        """Get all previous diagnostic results for the given store.  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.get_cloud_diagnostics_with_http_info(storeid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str storeid: ID of the Catalyst store (required)
        :return: CloudStoreDiagnosticsCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['storeid']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_cloud_diagnostics" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'storeid' is set
        if ('storeid' not in params or
                params['storeid'] is None):
            raise ValueError("Missing the required parameter `storeid` when calling `get_cloud_diagnostics`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'storeid' in params:
            path_params['storeid'] = params['storeid']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/cat/cloud-store-diagnostics/store/{storeid}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='CloudStoreDiagnosticsCollection',  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def run_cloud_diagnostics(self, storeid, **kwargs):  # noqa: E501
        """Starts diagnostic tests on the cloud store  # noqa: E501

        Create a Catalyst store.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.run_cloud_diagnostics(storeid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str storeid: ID of the Catalyst store (required)
        :param bool upload_included: Upload tests included
        :param bool download_included: Download tests included
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.run_cloud_diagnostics_with_http_info(storeid, **kwargs)  # noqa: E501
        else:
            (data) = self.run_cloud_diagnostics_with_http_info(storeid, **kwargs)  # noqa: E501
            return data

    def run_cloud_diagnostics_with_http_info(self, storeid, **kwargs):  # noqa: E501
        """Starts diagnostic tests on the cloud store  # noqa: E501

        Create a Catalyst store.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.run_cloud_diagnostics_with_http_info(storeid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str storeid: ID of the Catalyst store (required)
        :param bool upload_included: Upload tests included
        :param bool download_included: Download tests included
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['storeid', 'upload_included', 'download_included']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method run_cloud_diagnostics" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'storeid' is set
        if ('storeid' not in params or
                params['storeid'] is None):
            raise ValueError("Missing the required parameter `storeid` when calling `run_cloud_diagnostics`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'storeid' in params:
            path_params['storeid'] = params['storeid']  # noqa: E501

        query_params = []
        if 'upload_included' in params:
            query_params.append(('uploadIncluded', params['upload_included']))  # noqa: E501
        if 'download_included' in params:
            query_params.append(('downloadIncluded', params['download_included']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/cat/cloud-store-diagnostics/store/{storeid}', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
