# coding: utf-8

"""
    (C) Copyright 2018-2019 Hewlett Packard Enterprise Development LP

    Catalyst

    unused  # noqa: E501

    Component version: 10.3.15-SNAPSHOT
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from ..api_client import ApiClient


class CoFCInitiatorsApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_cofc_initiator(self, initiator, **kwargs):  # noqa: E501
        """Get a CoFC Initiator  # noqa: E501

        Return CoFC Initiator Details  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_cofc_initiator(initiator, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str initiator: ID of the CoFC initiator (required)
        :return: CofcInitiator
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.get_cofc_initiator_with_http_info(initiator, **kwargs)  # noqa: E501
        else:
            (data) = self.get_cofc_initiator_with_http_info(initiator, **kwargs)  # noqa: E501
            return data

    def get_cofc_initiator_with_http_info(self, initiator, **kwargs):  # noqa: E501
        """Get a CoFC Initiator  # noqa: E501

        Return CoFC Initiator Details  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.get_cofc_initiator_with_http_info(initiator, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str initiator: ID of the CoFC initiator (required)
        :return: CofcInitiator
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['initiator']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_cofc_initiator" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'initiator' is set
        if ('initiator' not in params or
                params['initiator'] is None):
            raise ValueError("Missing the required parameter `initiator` when calling `get_cofc_initiator`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'initiator' in params:
            path_params['initiator'] = params['initiator']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/cat/cofc-initiators/initiator/{initiator}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='CofcInitiator',  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_cofc_initiators(self, **kwargs):  # noqa: E501
        """Get CoFC Initiators  # noqa: E501

        Return all CoFC Initiator Details  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_cofc_initiators(async_=True)
        >>> result = thread.get()

        :param async_ bool
        :return: CoFCInitiatorsCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.get_cofc_initiators_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_cofc_initiators_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_cofc_initiators_with_http_info(self, **kwargs):  # noqa: E501
        """Get CoFC Initiators  # noqa: E501

        Return all CoFC Initiator Details  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.get_cofc_initiators_with_http_info(async_=True)
        >>> result = thread.get()

        :param async_ bool
        :return: CoFCInitiatorsCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = []  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_cofc_initiators" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/cat/cofc-initiators', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='CoFCInitiatorsCollection',  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
