# coding: utf-8

"""
    (C) Copyright 2018-2019 Hewlett Packard Enterprise Development LP

    Catalyst

    unused  # noqa: E501

    Component version: 10.3.15-SNAPSHOT
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from ..api_client import ApiClient


class CoFCRemoteHostsApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def create_cofc_remote_host(self, **kwargs):  # noqa: E501
        """Create CoFC new Remote Host Range  # noqa: E501

        Creates a new CoFC Remote Host Range, the new range must not overlap an already existing range  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.create_cofc_remote_host(async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param CofcRemoteHost body: Model of the CoFC Remote Host Properties
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.create_cofc_remote_host_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.create_cofc_remote_host_with_http_info(**kwargs)  # noqa: E501
            return data

    def create_cofc_remote_host_with_http_info(self, **kwargs):  # noqa: E501
        """Create CoFC new Remote Host Range  # noqa: E501

        Creates a new CoFC Remote Host Range, the new range must not overlap an already existing range  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.create_cofc_remote_host_with_http_info(async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param CofcRemoteHost body: Model of the CoFC Remote Host Properties
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_cofc_remote_host" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/cat/cofc-remote-host-ranges', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_cofc_remote_host(self, wwpn_start, **kwargs):  # noqa: E501
        """Delete CoFC Remote Host Range  # noqa: E501

        Deletes the specified CoFC Remote Host Range starting from the specified start world wide port name  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.delete_cofc_remote_host(wwpn_start, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str wwpn_start: World Wide Port Name used to get remote host ranges (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.delete_cofc_remote_host_with_http_info(wwpn_start, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_cofc_remote_host_with_http_info(wwpn_start, **kwargs)  # noqa: E501
            return data

    def delete_cofc_remote_host_with_http_info(self, wwpn_start, **kwargs):  # noqa: E501
        """Delete CoFC Remote Host Range  # noqa: E501

        Deletes the specified CoFC Remote Host Range starting from the specified start world wide port name  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.delete_cofc_remote_host_with_http_info(wwpn_start, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str wwpn_start: World Wide Port Name used to get remote host ranges (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['wwpn_start']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_cofc_remote_host" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'wwpn_start' is set
        if ('wwpn_start' not in params or
                params['wwpn_start'] is None):
            raise ValueError("Missing the required parameter `wwpn_start` when calling `delete_cofc_remote_host`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'wwpn_start' in params:
            path_params['wwpnStart'] = params['wwpn_start']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/cat/cofc-remote-host-ranges/wwpnStart/{wwpnStart}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_cofc_remote_host(self, wwpn_start, **kwargs):  # noqa: E501
        """Get CoFC Remote Host Range  # noqa: E501

        Returns a CoFC Remote Host range  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_cofc_remote_host(wwpn_start, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str wwpn_start: World Wide Port Name used to get remote host ranges (required)
        :return: CofcRemoteHost
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.get_cofc_remote_host_with_http_info(wwpn_start, **kwargs)  # noqa: E501
        else:
            (data) = self.get_cofc_remote_host_with_http_info(wwpn_start, **kwargs)  # noqa: E501
            return data

    def get_cofc_remote_host_with_http_info(self, wwpn_start, **kwargs):  # noqa: E501
        """Get CoFC Remote Host Range  # noqa: E501

        Returns a CoFC Remote Host range  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.get_cofc_remote_host_with_http_info(wwpn_start, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str wwpn_start: World Wide Port Name used to get remote host ranges (required)
        :return: CofcRemoteHost
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['wwpn_start']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_cofc_remote_host" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'wwpn_start' is set
        if ('wwpn_start' not in params or
                params['wwpn_start'] is None):
            raise ValueError("Missing the required parameter `wwpn_start` when calling `get_cofc_remote_host`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'wwpn_start' in params:
            path_params['wwpnStart'] = params['wwpn_start']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/cat/cofc-remote-host-ranges/wwpnStart/{wwpnStart}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='CofcRemoteHost',  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_cofc_remote_hosts(self, **kwargs):  # noqa: E501
        """Get CoFC Remote Hosts Ranges  # noqa: E501

        Returns a collection CoFC Remote Hosts Ranges  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_cofc_remote_hosts(async_=True)
        >>> result = thread.get()

        :param async_ bool
        :return: CoFCRemoteHostsCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.get_cofc_remote_hosts_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_cofc_remote_hosts_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_cofc_remote_hosts_with_http_info(self, **kwargs):  # noqa: E501
        """Get CoFC Remote Hosts Ranges  # noqa: E501

        Returns a collection CoFC Remote Hosts Ranges  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.get_cofc_remote_hosts_with_http_info(async_=True)
        >>> result = thread.get()

        :param async_ bool
        :return: CoFCRemoteHostsCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = []  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_cofc_remote_hosts" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/cat/cofc-remote-host-ranges', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='CoFCRemoteHostsCollection',  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
