# coding: utf-8

"""
    (C) Copyright 2018-2019 Hewlett Packard Enterprise Development LP

    Catalyst

    unused  # noqa: E501

    Component version: 10.3.15-SNAPSHOT
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from ..api_client import ApiClient


class StoresApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def create_cat_store(self, **kwargs):  # noqa: E501
        """Create Store  # noqa: E501

        Create a Catalyst store.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.create_cat_store(async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param StorePostModel body: Parameters of Catalyst store.
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.create_cat_store_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.create_cat_store_with_http_info(**kwargs)  # noqa: E501
            return data

    def create_cat_store_with_http_info(self, **kwargs):  # noqa: E501
        """Create Store  # noqa: E501

        Create a Catalyst store.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.create_cat_store_with_http_info(async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param StorePostModel body: Parameters of Catalyst store.
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_cat_store" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json', 'text/xml'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/cat/stores', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_cat_store(self, storeid, **kwargs):  # noqa: E501
        """Update Store  # noqa: E501

        Delete a Catalyst store.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.delete_cat_store(storeid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str storeid: ID of the Catalyst store (required)
        :param str cloud_delete_type: Integer representing the type of delete to carry out.
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.delete_cat_store_with_http_info(storeid, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_cat_store_with_http_info(storeid, **kwargs)  # noqa: E501
            return data

    def delete_cat_store_with_http_info(self, storeid, **kwargs):  # noqa: E501
        """Update Store  # noqa: E501

        Delete a Catalyst store.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.delete_cat_store_with_http_info(storeid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str storeid: ID of the Catalyst store (required)
        :param str cloud_delete_type: Integer representing the type of delete to carry out.
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['storeid', 'cloud_delete_type']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_cat_store" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'storeid' is set
        if ('storeid' not in params or
                params['storeid'] is None):
            raise ValueError("Missing the required parameter `storeid` when calling `delete_cat_store`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'storeid' in params:
            path_params['storeid'] = params['storeid']  # noqa: E501

        query_params = []
        if 'cloud_delete_type' in params:
            query_params.append(('cloudDeleteType', params['cloud_delete_type']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json', 'text/xml'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/cat/stores/store/{storeid}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_cat_store(self, storeid, **kwargs):  # noqa: E501
        """Get Store  # noqa: E501

        Get a single Catalyst store information.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_cat_store(storeid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str storeid: ID of the Catalyst store (required)
        :return: Store
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.get_cat_store_with_http_info(storeid, **kwargs)  # noqa: E501
        else:
            (data) = self.get_cat_store_with_http_info(storeid, **kwargs)  # noqa: E501
            return data

    def get_cat_store_with_http_info(self, storeid, **kwargs):  # noqa: E501
        """Get Store  # noqa: E501

        Get a single Catalyst store information.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.get_cat_store_with_http_info(storeid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str storeid: ID of the Catalyst store (required)
        :return: Store
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['storeid']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_cat_store" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'storeid' is set
        if ('storeid' not in params or
                params['storeid'] is None):
            raise ValueError("Missing the required parameter `storeid` when calling `get_cat_store`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'storeid' in params:
            path_params['storeid'] = params['storeid']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json', 'text/xml'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/cat/stores/store/{storeid}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Store',  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_cat_stores(self, **kwargs):  # noqa: E501
        """Get Stores  # noqa: E501

        Gets the collection of Catalyst stores on the appliance.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_cat_stores(async_=True)
        >>> result = thread.get()

        :param async_ bool
        :return: StoresCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.get_cat_stores_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_cat_stores_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_cat_stores_with_http_info(self, **kwargs):  # noqa: E501
        """Get Stores  # noqa: E501

        Gets the collection of Catalyst stores on the appliance.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.get_cat_stores_with_http_info(async_=True)
        >>> result = thread.get()

        :param async_ bool
        :return: StoresCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = []  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_cat_stores" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json', 'text/xml'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/cat/stores', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='StoresCollection',  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_cat_store(self, storeid, **kwargs):  # noqa: E501
        """Update Store  # noqa: E501

        Update a Catalyst store's properties.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.update_cat_store(storeid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str storeid: ID of the Catalyst store (required)
        :param StorePutModel body: Parameters of Catalyst store.
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.update_cat_store_with_http_info(storeid, **kwargs)  # noqa: E501
        else:
            (data) = self.update_cat_store_with_http_info(storeid, **kwargs)  # noqa: E501
            return data

    def update_cat_store_with_http_info(self, storeid, **kwargs):  # noqa: E501
        """Update Store  # noqa: E501

        Update a Catalyst store's properties.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.update_cat_store_with_http_info(storeid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str storeid: ID of the Catalyst store (required)
        :param StorePutModel body: Parameters of Catalyst store.
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['storeid', 'body']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_cat_store" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'storeid' is set
        if ('storeid' not in params or
                params['storeid'] is None):
            raise ValueError("Missing the required parameter `storeid` when calling `update_cat_store`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'storeid' in params:
            path_params['storeid'] = params['storeid']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json', 'text/xml'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/cat/stores/store/{storeid}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
