# coding: utf-8

"""
    (C) Copyright 2018-2019 Hewlett Packard Enterprise Development LP

    Catalyst

    unused  # noqa: E501

    Component version: 10.3.15-SNAPSHOT
"""


import pprint
import re  # noqa: F401

import six


class ItemFilter(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'order_ascending': 'bool',
        'meta_data_included': 'bool',
        'count': 'int',
        'filters': 'ItemFilters',
        'waypoint': 'str'
    }

    attribute_map = {
        'order_ascending': 'orderAscending',
        'meta_data_included': 'metaDataIncluded',
        'count': 'count',
        'filters': 'filters',
        'waypoint': 'waypoint'
    }

    def __init__(self, order_ascending=False, meta_data_included=False, count=None, filters=None, waypoint=None):  # noqa: E501
        """ItemFilter - a model defined in Swagger"""  # noqa: E501

        self._order_ascending = None
        self._meta_data_included = None
        self._count = None
        self._filters = None
        self._waypoint = None
        self.discriminator = None

        if order_ascending is not None:
            self.order_ascending = order_ascending
        if meta_data_included is not None:
            self.meta_data_included = meta_data_included
        if count is not None:
            self.count = count
        if filters is not None:
            self.filters = filters
        if waypoint is not None:
            self.waypoint = waypoint

    @property
    def order_ascending(self):
        """Gets the order_ascending of this ItemFilter.  # noqa: E501

        True if this filter orders the data in ascending date, otherewise descending  # noqa: E501

        :return: The order_ascending of this ItemFilter.  # noqa: E501
        :rtype: bool
        """
        return self._order_ascending

    @order_ascending.setter
    def order_ascending(self, order_ascending):
        """Sets the order_ascending of this ItemFilter.

        True if this filter orders the data in ascending date, otherewise descending  # noqa: E501

        :param order_ascending: The order_ascending of this ItemFilter.  # noqa: E501
        :type: bool
        """

        self._order_ascending = order_ascending

    @property
    def meta_data_included(self):
        """Gets the meta_data_included of this ItemFilter.  # noqa: E501

        True if this filter returns item meta data  # noqa: E501

        :return: The meta_data_included of this ItemFilter.  # noqa: E501
        :rtype: bool
        """
        return self._meta_data_included

    @meta_data_included.setter
    def meta_data_included(self, meta_data_included):
        """Sets the meta_data_included of this ItemFilter.

        True if this filter returns item meta data  # noqa: E501

        :param meta_data_included: The meta_data_included of this ItemFilter.  # noqa: E501
        :type: bool
        """

        self._meta_data_included = meta_data_included

    @property
    def count(self):
        """Gets the count of this ItemFilter.  # noqa: E501

        Count of items returned by the search using this filter  # noqa: E501

        :return: The count of this ItemFilter.  # noqa: E501
        :rtype: int
        """
        return self._count

    @count.setter
    def count(self, count):
        """Sets the count of this ItemFilter.

        Count of items returned by the search using this filter  # noqa: E501

        :param count: The count of this ItemFilter.  # noqa: E501
        :type: int
        """

        self._count = count

    @property
    def filters(self):
        """Gets the filters of this ItemFilter.  # noqa: E501

        Catalyst store items filter settings for the search  # noqa: E501

        :return: The filters of this ItemFilter.  # noqa: E501
        :rtype: ItemFilters
        """
        return self._filters

    @filters.setter
    def filters(self, filters):
        """Sets the filters of this ItemFilter.

        Catalyst store items filter settings for the search  # noqa: E501

        :param filters: The filters of this ItemFilter.  # noqa: E501
        :type: ItemFilters
        """

        self._filters = filters

    @property
    def waypoint(self):
        """Gets the waypoint of this ItemFilter.  # noqa: E501

        Waypoint to navigate the data returned using this filter  # noqa: E501

        :return: The waypoint of this ItemFilter.  # noqa: E501
        :rtype: str
        """
        return self._waypoint

    @waypoint.setter
    def waypoint(self, waypoint):
        """Sets the waypoint of this ItemFilter.

        Waypoint to navigate the data returned using this filter  # noqa: E501

        :param waypoint: The waypoint of this ItemFilter.  # noqa: E501
        :type: str
        """

        self._waypoint = waypoint

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ItemFilter, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ItemFilter):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
