# coding: utf-8

"""
    (C) Copyright 2018-2019 Hewlett Packard Enterprise Development LP

    Fibre Channel

    unused  # noqa: E501

    Component version: 3.0.3-SNAPSHOT
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from ..api_client import ApiClient


class PortsApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_all_fc_ports(self, **kwargs):  # noqa: E501
        """Get Fibre Channel Ports  # noqa: E501

        Returns details of the current Fibre Channel ports on the appliance  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_all_fc_ports(async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str start: Number of members in the collection to skip before returning
        :param str count: Number of members in the collection to skip before returning
        :return: FcPortCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.get_all_fc_ports_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_all_fc_ports_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_all_fc_ports_with_http_info(self, **kwargs):  # noqa: E501
        """Get Fibre Channel Ports  # noqa: E501

        Returns details of the current Fibre Channel ports on the appliance  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.get_all_fc_ports_with_http_info(async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str start: Number of members in the collection to skip before returning
        :param str count: Number of members in the collection to skip before returning
        :return: FcPortCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['start', 'count']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_all_fc_ports" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'start' in params:
            query_params.append(('start', params['start']))  # noqa: E501
        if 'count' in params:
            query_params.append(('count', params['count']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/fibre-channel/ports', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='FcPortCollection',  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_fc_port(self, port, **kwargs):  # noqa: E501
        """Get Fibre Channel Port  # noqa: E501

        Returns details of a single Fibre Channel port on the appliance  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_fc_port(port, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str port: ID of the FC Port (required)
        :return: FcPort
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.get_fc_port_with_http_info(port, **kwargs)  # noqa: E501
        else:
            (data) = self.get_fc_port_with_http_info(port, **kwargs)  # noqa: E501
            return data

    def get_fc_port_with_http_info(self, port, **kwargs):  # noqa: E501
        """Get Fibre Channel Port  # noqa: E501

        Returns details of a single Fibre Channel port on the appliance  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.get_fc_port_with_http_info(port, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str port: ID of the FC Port (required)
        :return: FcPort
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['port']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_fc_port" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'port' is set
        if ('port' not in params or
                params['port'] is None):
            raise ValueError("Missing the required parameter `port` when calling `get_fc_port`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'port' in params:
            path_params['port'] = params['port']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/fibre-channel/ports/port/{port}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='FcPort',  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def modify_fc_port(self, port, **kwargs):  # noqa: E501
        """Modify Fibre Channel Port  # noqa: E501

        Modifies details of a single Fibre Channel port on the appliance  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.modify_fc_port(port, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str port: ID of the port to modify (required)
        :param ModifyFcPort body: Modifiable settings
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.modify_fc_port_with_http_info(port, **kwargs)  # noqa: E501
        else:
            (data) = self.modify_fc_port_with_http_info(port, **kwargs)  # noqa: E501
            return data

    def modify_fc_port_with_http_info(self, port, **kwargs):  # noqa: E501
        """Modify Fibre Channel Port  # noqa: E501

        Modifies details of a single Fibre Channel port on the appliance  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.modify_fc_port_with_http_info(port, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str port: ID of the port to modify (required)
        :param ModifyFcPort body: Modifiable settings
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['port', 'body']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method modify_fc_port" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'port' is set
        if ('port' not in params or
                params['port'] is None):
            raise ValueError("Missing the required parameter `port` when calling `modify_fc_port`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'port' in params:
            path_params['port'] = params['port']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/fibre-channel/ports/port/{port}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
