# coding: utf-8

"""
    (C) Copyright 2018-2019 Hewlett Packard Enterprise Development LP

    Fibre Channel

    unused  # noqa: E501

    Component version: 3.0.3-SNAPSHOT
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from ..api_client import ApiClient


class TargetLoginsApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_logins_for_target(self, wwn, **kwargs):  # noqa: E501
        """Get Fibre Channel Logins  # noqa: E501

        Returns details of initiators logged into a specific device on the appliance  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_logins_for_target(wwn, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str wwn: WWN of the Target. (required)
        :param str start: Number of members in the collection to skip before returning
        :param str count: Number of members in the collection to skip before returning
        :return: FcTargetLoginCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.get_logins_for_target_with_http_info(wwn, **kwargs)  # noqa: E501
        else:
            (data) = self.get_logins_for_target_with_http_info(wwn, **kwargs)  # noqa: E501
            return data

    def get_logins_for_target_with_http_info(self, wwn, **kwargs):  # noqa: E501
        """Get Fibre Channel Logins  # noqa: E501

        Returns details of initiators logged into a specific device on the appliance  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.get_logins_for_target_with_http_info(wwn, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str wwn: WWN of the Target. (required)
        :param str start: Number of members in the collection to skip before returning
        :param str count: Number of members in the collection to skip before returning
        :return: FcTargetLoginCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['wwn', 'start', 'count']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_logins_for_target" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'wwn' is set
        if ('wwn' not in params or
                params['wwn'] is None):
            raise ValueError("Missing the required parameter `wwn` when calling `get_logins_for_target`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'wwn' in params:
            path_params['wwn'] = params['wwn']  # noqa: E501

        query_params = []
        if 'start' in params:
            query_params.append(('start', params['start']))  # noqa: E501
        if 'count' in params:
            query_params.append(('count', params['count']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/fibre-channel/target-logins/wwn/{wwn}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='FcTargetLoginCollection',  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
