# coding: utf-8

"""
    (C) Copyright 2018-2019 Hewlett Packard Enterprise Development LP

    NAS

    unused  # noqa: E501

    Component version: 3.1.5-SNAPSHOT
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from ..api_client import ApiClient


class SharePermissionsApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_nas_share_permission(self, shareid, id, **kwargs):  # noqa: E501
        """Get Share Permission  # noqa: E501

        Get properties of share permission according to the id of permission for the given share  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_nas_share_permission(shareid, id, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str shareid: shareId (required)
        :param str id: permissionId (required)
        :return: SharePermission
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.get_nas_share_permission_with_http_info(shareid, id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_nas_share_permission_with_http_info(shareid, id, **kwargs)  # noqa: E501
            return data

    def get_nas_share_permission_with_http_info(self, shareid, id, **kwargs):  # noqa: E501
        """Get Share Permission  # noqa: E501

        Get properties of share permission according to the id of permission for the given share  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.get_nas_share_permission_with_http_info(shareid, id, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str shareid: shareId (required)
        :param str id: permissionId (required)
        :return: SharePermission
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['shareid', 'id']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_nas_share_permission" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'shareid' is set
        if ('shareid' not in params or
                params['shareid'] is None):
            raise ValueError("Missing the required parameter `shareid` when calling `get_nas_share_permission`")  # noqa: E501
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `get_nas_share_permission`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'shareid' in params:
            path_params['shareid'] = params['shareid']  # noqa: E501
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/data-services/nas/share-permissions/share/{shareid}/permission/{id}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SharePermission',  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_nas_share_permissions(self, shareid, **kwargs):  # noqa: E501
        """Get Share Permissions  # noqa: E501

        Returns the list of NAS share permissions for the given share id  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_nas_share_permissions(shareid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str shareid: shareId (required)
        :return: SharePermissionModelCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.get_nas_share_permissions_with_http_info(shareid, **kwargs)  # noqa: E501
        else:
            (data) = self.get_nas_share_permissions_with_http_info(shareid, **kwargs)  # noqa: E501
            return data

    def get_nas_share_permissions_with_http_info(self, shareid, **kwargs):  # noqa: E501
        """Get Share Permissions  # noqa: E501

        Returns the list of NAS share permissions for the given share id  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.get_nas_share_permissions_with_http_info(shareid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str shareid: shareId (required)
        :return: SharePermissionModelCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['shareid']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_nas_share_permissions" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'shareid' is set
        if ('shareid' not in params or
                params['shareid'] is None):
            raise ValueError("Missing the required parameter `shareid` when calling `get_nas_share_permissions`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'shareid' in params:
            path_params['shareid'] = params['shareid']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/data-services/nas/share-permissions/share/{shareid}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SharePermissionModelCollection',  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_nas_share_permission(self, shareid, id, body, **kwargs):  # noqa: E501
        """Updates NAS Share permission  # noqa: E501

        Updates NAS Share permission with provided properties for the given share  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.update_nas_share_permission(shareid, id, body, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str shareid: shareId (required)
        :param str id: permissionId (required)
        :param SharePermission body: NasSharePermissionModel (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.update_nas_share_permission_with_http_info(shareid, id, body, **kwargs)  # noqa: E501
        else:
            (data) = self.update_nas_share_permission_with_http_info(shareid, id, body, **kwargs)  # noqa: E501
            return data

    def update_nas_share_permission_with_http_info(self, shareid, id, body, **kwargs):  # noqa: E501
        """Updates NAS Share permission  # noqa: E501

        Updates NAS Share permission with provided properties for the given share  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.update_nas_share_permission_with_http_info(shareid, id, body, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str shareid: shareId (required)
        :param str id: permissionId (required)
        :param SharePermission body: NasSharePermissionModel (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['shareid', 'id', 'body']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_nas_share_permission" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'shareid' is set
        if ('shareid' not in params or
                params['shareid'] is None):
            raise ValueError("Missing the required parameter `shareid` when calling `update_nas_share_permission`")  # noqa: E501
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `update_nas_share_permission`")  # noqa: E501
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `update_nas_share_permission`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'shareid' in params:
            path_params['shareid'] = params['shareid']  # noqa: E501
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/data-services/nas/share-permissions/share/{shareid}/permission/{id}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
