# coding: utf-8

"""
    (C) Copyright 2018-2019 Hewlett Packard Enterprise Development LP

    NAS

    unused  # noqa: E501

    Component version: 3.1.5-SNAPSHOT
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from ..api_client import ApiClient


class StorageParametricsReportApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_nas_storage(self, start_date, **kwargs):  # noqa: E501
        """List that provides storage metrics for the NAS at appliance level  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_nas_storage(start_date, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param datetime start_date: startDate (required)
        :param datetime end_date: endDate
        :param str samples: samples
        :return: ShareParametricsStorageCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.get_nas_storage_with_http_info(start_date, **kwargs)  # noqa: E501
        else:
            (data) = self.get_nas_storage_with_http_info(start_date, **kwargs)  # noqa: E501
            return data

    def get_nas_storage_with_http_info(self, start_date, **kwargs):  # noqa: E501
        """List that provides storage metrics for the NAS at appliance level  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.get_nas_storage_with_http_info(start_date, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param datetime start_date: startDate (required)
        :param datetime end_date: endDate
        :param str samples: samples
        :return: ShareParametricsStorageCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['start_date', 'end_date', 'samples']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_nas_storage" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'start_date' is set
        if ('start_date' not in params or
                params['start_date'] is None):
            raise ValueError("Missing the required parameter `start_date` when calling `get_nas_storage`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'start_date' in params:
            query_params.append(('startDate', params['start_date']))  # noqa: E501
        if 'end_date' in params:
            query_params.append(('endDate', params['end_date']))  # noqa: E501
        if 'samples' in params:
            query_params.append(('samples', params['samples']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/data-services/nas/parametrics-storage', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ShareParametricsStorageCollection',  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_nas_storage_by_id(self, shareid, start_date, **kwargs):  # noqa: E501
        """List that provides storage metrics for the NAS share  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_nas_storage_by_id(shareid, start_date, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str shareid: shareId (required)
        :param datetime start_date: startDate (required)
        :param datetime end_date: endDate
        :param str samples: samples
        :param bool include_historical: includeHistorical
        :return: list[ShareParametricsStorageSample]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.get_nas_storage_by_id_with_http_info(shareid, start_date, **kwargs)  # noqa: E501
        else:
            (data) = self.get_nas_storage_by_id_with_http_info(shareid, start_date, **kwargs)  # noqa: E501
            return data

    def get_nas_storage_by_id_with_http_info(self, shareid, start_date, **kwargs):  # noqa: E501
        """List that provides storage metrics for the NAS share  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.get_nas_storage_by_id_with_http_info(shareid, start_date, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str shareid: shareId (required)
        :param datetime start_date: startDate (required)
        :param datetime end_date: endDate
        :param str samples: samples
        :param bool include_historical: includeHistorical
        :return: list[ShareParametricsStorageSample]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['shareid', 'start_date', 'end_date', 'samples', 'include_historical']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_nas_storage_by_id" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'shareid' is set
        if ('shareid' not in params or
                params['shareid'] is None):
            raise ValueError("Missing the required parameter `shareid` when calling `get_nas_storage_by_id`")  # noqa: E501
        # verify the required parameter 'start_date' is set
        if ('start_date' not in params or
                params['start_date'] is None):
            raise ValueError("Missing the required parameter `start_date` when calling `get_nas_storage_by_id`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'shareid' in params:
            path_params['shareid'] = params['shareid']  # noqa: E501

        query_params = []
        if 'start_date' in params:
            query_params.append(('startDate', params['start_date']))  # noqa: E501
        if 'end_date' in params:
            query_params.append(('endDate', params['end_date']))  # noqa: E501
        if 'samples' in params:
            query_params.append(('samples', params['samples']))  # noqa: E501
        if 'include_historical' in params:
            query_params.append(('includeHistorical', params['include_historical']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/data-services/nas/parametrics-storage/share/{shareid}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[ShareParametricsStorageSample]',  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
