# coding: utf-8

"""
    (C) Copyright 2018-2019 Hewlett Packard Enterprise Development LP

    Replication

    unused  # noqa: E501

    Component version: 3.3.11-SNAPSHOT
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from ..api_client import ApiClient


class BlackoutWindowsApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_blackout_window(self, day, **kwargs):  # noqa: E501
        """Get a single blackout window  # noqa: E501

        Returns the specified day's blackout window settings  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_blackout_window(day, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str day: Number representing the day of the week (required)
        :return: BlackoutWindow
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.get_blackout_window_with_http_info(day, **kwargs)  # noqa: E501
        else:
            (data) = self.get_blackout_window_with_http_info(day, **kwargs)  # noqa: E501
            return data

    def get_blackout_window_with_http_info(self, day, **kwargs):  # noqa: E501
        """Get a single blackout window  # noqa: E501

        Returns the specified day's blackout window settings  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.get_blackout_window_with_http_info(day, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str day: Number representing the day of the week (required)
        :return: BlackoutWindow
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['day']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_blackout_window" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'day' is set
        if ('day' not in params or
                params['day'] is None):
            raise ValueError("Missing the required parameter `day` when calling `get_blackout_window`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'day' in params:
            path_params['day'] = params['day']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/rep/blackout-windows/day/{day}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='BlackoutWindow',  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_blackout_windows(self, **kwargs):  # noqa: E501
        """Get all blackout windows  # noqa: E501

        Returns the blackout settings for all 7 days  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_blackout_windows(async_=True)
        >>> result = thread.get()

        :param async_ bool
        :return: BlackoutWindowsCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.get_blackout_windows_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_blackout_windows_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_blackout_windows_with_http_info(self, **kwargs):  # noqa: E501
        """Get all blackout windows  # noqa: E501

        Returns the blackout settings for all 7 days  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.get_blackout_windows_with_http_info(async_=True)
        >>> result = thread.get()

        :param async_ bool
        :return: BlackoutWindowsCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = []  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_blackout_windows" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/rep/blackout-windows', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='BlackoutWindowsCollection',  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_blackout_window(self, day, **kwargs):  # noqa: E501
        """Update a single blackout window  # noqa: E501

        Updates the specified day's blackout window settings  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.update_blackout_window(day, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str day: Number representing the day of the week (required)
        :param BlackoutWindowPutModel body: Model of the Replication Blackout Window
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.update_blackout_window_with_http_info(day, **kwargs)  # noqa: E501
        else:
            (data) = self.update_blackout_window_with_http_info(day, **kwargs)  # noqa: E501
            return data

    def update_blackout_window_with_http_info(self, day, **kwargs):  # noqa: E501
        """Update a single blackout window  # noqa: E501

        Updates the specified day's blackout window settings  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.update_blackout_window_with_http_info(day, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str day: Number representing the day of the week (required)
        :param BlackoutWindowPutModel body: Model of the Replication Blackout Window
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['day', 'body']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_blackout_window" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'day' is set
        if ('day' not in params or
                params['day'] is None):
            raise ValueError("Missing the required parameter `day` when calling `update_blackout_window`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'day' in params:
            path_params['day'] = params['day']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/rep/blackout-windows/day/{day}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
