# coding: utf-8

"""
    (C) Copyright 2018-2019 Hewlett Packard Enterprise Development LP

    Replication

    unused  # noqa: E501

    Component version: 3.3.11-SNAPSHOT
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from ..api_client import ApiClient


class LibrarySourcePermissionsApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_source_library_permission(self, permission_id, libraryid, **kwargs):  # noqa: E501
        """Get a single source library permissions  # noqa: E501

        Returns the specified source library permission details  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_source_library_permission(permission_id, libraryid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str permission_id: Source Permission ID (required)
        :param str libraryid: Library ID (required)
        :return: SourceLibraryPermissions
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.get_source_library_permission_with_http_info(permission_id, libraryid, **kwargs)  # noqa: E501
        else:
            (data) = self.get_source_library_permission_with_http_info(permission_id, libraryid, **kwargs)  # noqa: E501
            return data

    def get_source_library_permission_with_http_info(self, permission_id, libraryid, **kwargs):  # noqa: E501
        """Get a single source library permissions  # noqa: E501

        Returns the specified source library permission details  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.get_source_library_permission_with_http_info(permission_id, libraryid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str permission_id: Source Permission ID (required)
        :param str libraryid: Library ID (required)
        :return: SourceLibraryPermissions
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['permission_id', 'libraryid']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_source_library_permission" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'permission_id' is set
        if ('permission_id' not in params or
                params['permission_id'] is None):
            raise ValueError("Missing the required parameter `permission_id` when calling `get_source_library_permission`")  # noqa: E501
        # verify the required parameter 'libraryid' is set
        if ('libraryid' not in params or
                params['libraryid'] is None):
            raise ValueError("Missing the required parameter `libraryid` when calling `get_source_library_permission`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'permission_id' in params:
            path_params['permissionId'] = params['permission_id']  # noqa: E501
        if 'libraryid' in params:
            path_params['libraryid'] = params['libraryid']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/rep/source-library-permissions/source-permission/{permissionId}/library/{libraryid}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SourceLibraryPermissions',  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_source_library_permissions(self, permission_id, **kwargs):  # noqa: E501
        """Get all source library permissions  # noqa: E501

        Returns the list of source library permissions.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_source_library_permissions(permission_id, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str permission_id: Source Permission ID (required)
        :return: SourceLibraryPermissionsCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.get_source_library_permissions_with_http_info(permission_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_source_library_permissions_with_http_info(permission_id, **kwargs)  # noqa: E501
            return data

    def get_source_library_permissions_with_http_info(self, permission_id, **kwargs):  # noqa: E501
        """Get all source library permissions  # noqa: E501

        Returns the list of source library permissions.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.get_source_library_permissions_with_http_info(permission_id, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str permission_id: Source Permission ID (required)
        :return: SourceLibraryPermissionsCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['permission_id']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_source_library_permissions" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'permission_id' is set
        if ('permission_id' not in params or
                params['permission_id'] is None):
            raise ValueError("Missing the required parameter `permission_id` when calling `get_source_library_permissions`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'permission_id' in params:
            path_params['permissionId'] = params['permission_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/rep/source-library-permissions/source-permission/{permissionId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SourceLibraryPermissionsCollection',  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_source_library_permission(self, permission_id, libraryid, **kwargs):  # noqa: E501
        """Updates a source library permission  # noqa: E501

        Updates the source library permission with specified properties  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.update_source_library_permission(permission_id, libraryid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str permission_id: Source Permission ID (required)
        :param str libraryid: Library ID (required)
        :param SourceLibraryPermissionsPutModel body: Properties of source library permission
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.update_source_library_permission_with_http_info(permission_id, libraryid, **kwargs)  # noqa: E501
        else:
            (data) = self.update_source_library_permission_with_http_info(permission_id, libraryid, **kwargs)  # noqa: E501
            return data

    def update_source_library_permission_with_http_info(self, permission_id, libraryid, **kwargs):  # noqa: E501
        """Updates a source library permission  # noqa: E501

        Updates the source library permission with specified properties  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.update_source_library_permission_with_http_info(permission_id, libraryid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str permission_id: Source Permission ID (required)
        :param str libraryid: Library ID (required)
        :param SourceLibraryPermissionsPutModel body: Properties of source library permission
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['permission_id', 'libraryid', 'body']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_source_library_permission" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'permission_id' is set
        if ('permission_id' not in params or
                params['permission_id'] is None):
            raise ValueError("Missing the required parameter `permission_id` when calling `update_source_library_permission`")  # noqa: E501
        # verify the required parameter 'libraryid' is set
        if ('libraryid' not in params or
                params['libraryid'] is None):
            raise ValueError("Missing the required parameter `libraryid` when calling `update_source_library_permission`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'permission_id' in params:
            path_params['permissionId'] = params['permission_id']  # noqa: E501
        if 'libraryid' in params:
            path_params['libraryid'] = params['libraryid']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/rep/source-library-permissions/source-permission/{permissionId}/library/{libraryid}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
