# coding: utf-8

"""
    (C) Copyright 2018-2019 Hewlett Packard Enterprise Development LP

    Replication

    unused  # noqa: E501

    Component version: 3.3.11-SNAPSHOT
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from ..api_client import ApiClient


class NASShareMappingFilesApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_rep_share_mapping_file(self, shareid, mappingid, fileid, **kwargs):  # noqa: E501
        """Get a single mapped file  # noqa: E501

        Returns an individual mapped file in the specified mapping  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_rep_share_mapping_file(shareid, mappingid, fileid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str shareid: Unique share id (required)
        :param str mappingid: Unique mapping id in the share (required)
        :param str fileid: Unique file id in the mapping (required)
        :return: ShareMappingFiles
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.get_rep_share_mapping_file_with_http_info(shareid, mappingid, fileid, **kwargs)  # noqa: E501
        else:
            (data) = self.get_rep_share_mapping_file_with_http_info(shareid, mappingid, fileid, **kwargs)  # noqa: E501
            return data

    def get_rep_share_mapping_file_with_http_info(self, shareid, mappingid, fileid, **kwargs):  # noqa: E501
        """Get a single mapped file  # noqa: E501

        Returns an individual mapped file in the specified mapping  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.get_rep_share_mapping_file_with_http_info(shareid, mappingid, fileid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str shareid: Unique share id (required)
        :param str mappingid: Unique mapping id in the share (required)
        :param str fileid: Unique file id in the mapping (required)
        :return: ShareMappingFiles
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['shareid', 'mappingid', 'fileid']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_rep_share_mapping_file" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'shareid' is set
        if ('shareid' not in params or
                params['shareid'] is None):
            raise ValueError("Missing the required parameter `shareid` when calling `get_rep_share_mapping_file`")  # noqa: E501
        # verify the required parameter 'mappingid' is set
        if ('mappingid' not in params or
                params['mappingid'] is None):
            raise ValueError("Missing the required parameter `mappingid` when calling `get_rep_share_mapping_file`")  # noqa: E501
        # verify the required parameter 'fileid' is set
        if ('fileid' not in params or
                params['fileid'] is None):
            raise ValueError("Missing the required parameter `fileid` when calling `get_rep_share_mapping_file`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'shareid' in params:
            path_params['shareid'] = params['shareid']  # noqa: E501
        if 'mappingid' in params:
            path_params['mappingid'] = params['mappingid']  # noqa: E501
        if 'fileid' in params:
            path_params['fileid'] = params['fileid']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/rep/share-mapping-files/share/{shareid}/mapping/{mappingid}/file/{fileid}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ShareMappingFiles',  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_rep_share_mapping_files(self, shareid, mappingid, **kwargs):  # noqa: E501
        """Get a collection of files  # noqa: E501

        Returns a collection of files (limited to a maximum of 1000 files per request)  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_rep_share_mapping_files(shareid, mappingid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str shareid: Unique share id (required)
        :param str mappingid: Unique mapping id in the share (required)
        :param str waypoint: Waypoint to use for request
        :param str count: Count to return for request
        :return: ShareMappingFilesCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.get_rep_share_mapping_files_with_http_info(shareid, mappingid, **kwargs)  # noqa: E501
        else:
            (data) = self.get_rep_share_mapping_files_with_http_info(shareid, mappingid, **kwargs)  # noqa: E501
            return data

    def get_rep_share_mapping_files_with_http_info(self, shareid, mappingid, **kwargs):  # noqa: E501
        """Get a collection of files  # noqa: E501

        Returns a collection of files (limited to a maximum of 1000 files per request)  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.get_rep_share_mapping_files_with_http_info(shareid, mappingid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str shareid: Unique share id (required)
        :param str mappingid: Unique mapping id in the share (required)
        :param str waypoint: Waypoint to use for request
        :param str count: Count to return for request
        :return: ShareMappingFilesCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['shareid', 'mappingid', 'waypoint', 'count']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_rep_share_mapping_files" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'shareid' is set
        if ('shareid' not in params or
                params['shareid'] is None):
            raise ValueError("Missing the required parameter `shareid` when calling `get_rep_share_mapping_files`")  # noqa: E501
        # verify the required parameter 'mappingid' is set
        if ('mappingid' not in params or
                params['mappingid'] is None):
            raise ValueError("Missing the required parameter `mappingid` when calling `get_rep_share_mapping_files`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'shareid' in params:
            path_params['shareid'] = params['shareid']  # noqa: E501
        if 'mappingid' in params:
            path_params['mappingid'] = params['mappingid']  # noqa: E501

        query_params = []
        if 'waypoint' in params:
            query_params.append(('waypoint', params['waypoint']))  # noqa: E501
        if 'count' in params:
            query_params.append(('count', params['count']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/rep/share-mapping-files/share/{shareid}/mapping/{mappingid}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ShareMappingFilesCollection',  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_rep_share_mapping_files_filter(self, shareid, mappingid, **kwargs):  # noqa: E501
        """Get a filtered collection of files  # noqa: E501

        Returns a filtered collection of files (limited to a maximum of 1000 items per request)  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_rep_share_mapping_files_filter(shareid, mappingid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str shareid: Unique share id (required)
        :param str mappingid: Unique mapping id in the share (required)
        :param str waypoint: Waypoint to use for request
        :param ShareMappingFileFilterModel body: filter
        :return: ShareMappingFilesCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.get_rep_share_mapping_files_filter_with_http_info(shareid, mappingid, **kwargs)  # noqa: E501
        else:
            (data) = self.get_rep_share_mapping_files_filter_with_http_info(shareid, mappingid, **kwargs)  # noqa: E501
            return data

    def get_rep_share_mapping_files_filter_with_http_info(self, shareid, mappingid, **kwargs):  # noqa: E501
        """Get a filtered collection of files  # noqa: E501

        Returns a filtered collection of files (limited to a maximum of 1000 items per request)  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.get_rep_share_mapping_files_filter_with_http_info(shareid, mappingid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str shareid: Unique share id (required)
        :param str mappingid: Unique mapping id in the share (required)
        :param str waypoint: Waypoint to use for request
        :param ShareMappingFileFilterModel body: filter
        :return: ShareMappingFilesCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['shareid', 'mappingid', 'waypoint', 'body']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_rep_share_mapping_files_filter" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'shareid' is set
        if ('shareid' not in params or
                params['shareid'] is None):
            raise ValueError("Missing the required parameter `shareid` when calling `get_rep_share_mapping_files_filter`")  # noqa: E501
        # verify the required parameter 'mappingid' is set
        if ('mappingid' not in params or
                params['mappingid'] is None):
            raise ValueError("Missing the required parameter `mappingid` when calling `get_rep_share_mapping_files_filter`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'shareid' in params:
            path_params['shareid'] = params['shareid']  # noqa: E501
        if 'mappingid' in params:
            path_params['mappingid'] = params['mappingid']  # noqa: E501

        query_params = []
        if 'waypoint' in params:
            query_params.append(('waypoint', params['waypoint']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/rep/share-mapping-files/share/{shareid}/mapping/{mappingid}/filter', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ShareMappingFilesCollection',  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_rep_share_mapping_file(self, shareid, mappingid, fileid, **kwargs):  # noqa: E501
        """Updates the share file details  # noqa: E501

        Update the share file details with the given property  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.update_rep_share_mapping_file(shareid, mappingid, fileid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str shareid: Unique share id (required)
        :param str mappingid: Unique mapping id in the share (required)
        :param str fileid: Unique file id in the mapping (required)
        :param ShareMappingFilesPutModel body: Properties of share mapping file to be updated
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.update_rep_share_mapping_file_with_http_info(shareid, mappingid, fileid, **kwargs)  # noqa: E501
        else:
            (data) = self.update_rep_share_mapping_file_with_http_info(shareid, mappingid, fileid, **kwargs)  # noqa: E501
            return data

    def update_rep_share_mapping_file_with_http_info(self, shareid, mappingid, fileid, **kwargs):  # noqa: E501
        """Updates the share file details  # noqa: E501

        Update the share file details with the given property  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.update_rep_share_mapping_file_with_http_info(shareid, mappingid, fileid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str shareid: Unique share id (required)
        :param str mappingid: Unique mapping id in the share (required)
        :param str fileid: Unique file id in the mapping (required)
        :param ShareMappingFilesPutModel body: Properties of share mapping file to be updated
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['shareid', 'mappingid', 'fileid', 'body']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_rep_share_mapping_file" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'shareid' is set
        if ('shareid' not in params or
                params['shareid'] is None):
            raise ValueError("Missing the required parameter `shareid` when calling `update_rep_share_mapping_file`")  # noqa: E501
        # verify the required parameter 'mappingid' is set
        if ('mappingid' not in params or
                params['mappingid'] is None):
            raise ValueError("Missing the required parameter `mappingid` when calling `update_rep_share_mapping_file`")  # noqa: E501
        # verify the required parameter 'fileid' is set
        if ('fileid' not in params or
                params['fileid'] is None):
            raise ValueError("Missing the required parameter `fileid` when calling `update_rep_share_mapping_file`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'shareid' in params:
            path_params['shareid'] = params['shareid']  # noqa: E501
        if 'mappingid' in params:
            path_params['mappingid'] = params['mappingid']  # noqa: E501
        if 'fileid' in params:
            path_params['fileid'] = params['fileid']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/rep/share-mapping-files/share/{shareid}/mapping/{mappingid}/file/{fileid}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
