# coding: utf-8

"""
    (C) Copyright 2018-2019 Hewlett Packard Enterprise Development LP

    Replication

    unused  # noqa: E501

    Component version: 3.3.11-SNAPSHOT
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from ..api_client import ApiClient


class VTLLibraryMappingSlotsApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_rep_library_mapping_slot(self, libraryid, mappingid, slotid, **kwargs):  # noqa: E501
        """Get a single mapped slot  # noqa: E501

        Returns an individual mapped slot in the specified mapping  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_rep_library_mapping_slot(libraryid, mappingid, slotid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str libraryid: Unique id of the library (required)
        :param str mappingid: Unique id of the mapping in the library (required)
        :param str slotid: Unique id of the slot in the mapping (required)
        :return: LibraryMappingSlotsModel
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.get_rep_library_mapping_slot_with_http_info(libraryid, mappingid, slotid, **kwargs)  # noqa: E501
        else:
            (data) = self.get_rep_library_mapping_slot_with_http_info(libraryid, mappingid, slotid, **kwargs)  # noqa: E501
            return data

    def get_rep_library_mapping_slot_with_http_info(self, libraryid, mappingid, slotid, **kwargs):  # noqa: E501
        """Get a single mapped slot  # noqa: E501

        Returns an individual mapped slot in the specified mapping  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.get_rep_library_mapping_slot_with_http_info(libraryid, mappingid, slotid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str libraryid: Unique id of the library (required)
        :param str mappingid: Unique id of the mapping in the library (required)
        :param str slotid: Unique id of the slot in the mapping (required)
        :return: LibraryMappingSlotsModel
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['libraryid', 'mappingid', 'slotid']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_rep_library_mapping_slot" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'libraryid' is set
        if ('libraryid' not in params or
                params['libraryid'] is None):
            raise ValueError("Missing the required parameter `libraryid` when calling `get_rep_library_mapping_slot`")  # noqa: E501
        # verify the required parameter 'mappingid' is set
        if ('mappingid' not in params or
                params['mappingid'] is None):
            raise ValueError("Missing the required parameter `mappingid` when calling `get_rep_library_mapping_slot`")  # noqa: E501
        # verify the required parameter 'slotid' is set
        if ('slotid' not in params or
                params['slotid'] is None):
            raise ValueError("Missing the required parameter `slotid` when calling `get_rep_library_mapping_slot`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'libraryid' in params:
            path_params['libraryid'] = params['libraryid']  # noqa: E501
        if 'mappingid' in params:
            path_params['mappingid'] = params['mappingid']  # noqa: E501
        if 'slotid' in params:
            path_params['slotid'] = params['slotid']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/rep/library-mapping-slots/library/{libraryid}/mapping/{mappingid}/slot/{slotid}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='LibraryMappingSlotsModel',  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_rep_library_mapping_slots(self, libraryid, mappingid, **kwargs):  # noqa: E501
        """Get a collection of slots  # noqa: E501

        Returns a collection of slots (limited to a maximum of 1000 items per request)  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_rep_library_mapping_slots(libraryid, mappingid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str libraryid: Unique id of the library (required)
        :param str mappingid: Unique id of the mapping in the library (required)
        :param str waypoint: Waypoint to use for request
        :param str count: Count to return for request
        :return: LibraryMappingSlotsCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.get_rep_library_mapping_slots_with_http_info(libraryid, mappingid, **kwargs)  # noqa: E501
        else:
            (data) = self.get_rep_library_mapping_slots_with_http_info(libraryid, mappingid, **kwargs)  # noqa: E501
            return data

    def get_rep_library_mapping_slots_with_http_info(self, libraryid, mappingid, **kwargs):  # noqa: E501
        """Get a collection of slots  # noqa: E501

        Returns a collection of slots (limited to a maximum of 1000 items per request)  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.get_rep_library_mapping_slots_with_http_info(libraryid, mappingid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str libraryid: Unique id of the library (required)
        :param str mappingid: Unique id of the mapping in the library (required)
        :param str waypoint: Waypoint to use for request
        :param str count: Count to return for request
        :return: LibraryMappingSlotsCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['libraryid', 'mappingid', 'waypoint', 'count']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_rep_library_mapping_slots" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'libraryid' is set
        if ('libraryid' not in params or
                params['libraryid'] is None):
            raise ValueError("Missing the required parameter `libraryid` when calling `get_rep_library_mapping_slots`")  # noqa: E501
        # verify the required parameter 'mappingid' is set
        if ('mappingid' not in params or
                params['mappingid'] is None):
            raise ValueError("Missing the required parameter `mappingid` when calling `get_rep_library_mapping_slots`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'libraryid' in params:
            path_params['libraryid'] = params['libraryid']  # noqa: E501
        if 'mappingid' in params:
            path_params['mappingid'] = params['mappingid']  # noqa: E501

        query_params = []
        if 'waypoint' in params:
            query_params.append(('waypoint', params['waypoint']))  # noqa: E501
        if 'count' in params:
            query_params.append(('count', params['count']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/rep/library-mapping-slots/library/{libraryid}/mapping/{mappingid}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='LibraryMappingSlotsCollection',  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_rep_library_mapping_slots_filter(self, libraryid, mappingid, **kwargs):  # noqa: E501
        """Get a filtered collection of slots  # noqa: E501

        Returns a filtered collection of slots (limited to a maximum of 1000 items per request)  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_rep_library_mapping_slots_filter(libraryid, mappingid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str libraryid: Unique id of the library (required)
        :param str mappingid: Unique id of the mapping in the library (required)
        :param str waypoint: Waypoint to use for request
        :param LibraryMappingSlotFilterModel body: filter
        :return: LibraryMappingSlotsCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.get_rep_library_mapping_slots_filter_with_http_info(libraryid, mappingid, **kwargs)  # noqa: E501
        else:
            (data) = self.get_rep_library_mapping_slots_filter_with_http_info(libraryid, mappingid, **kwargs)  # noqa: E501
            return data

    def get_rep_library_mapping_slots_filter_with_http_info(self, libraryid, mappingid, **kwargs):  # noqa: E501
        """Get a filtered collection of slots  # noqa: E501

        Returns a filtered collection of slots (limited to a maximum of 1000 items per request)  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.get_rep_library_mapping_slots_filter_with_http_info(libraryid, mappingid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str libraryid: Unique id of the library (required)
        :param str mappingid: Unique id of the mapping in the library (required)
        :param str waypoint: Waypoint to use for request
        :param LibraryMappingSlotFilterModel body: filter
        :return: LibraryMappingSlotsCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['libraryid', 'mappingid', 'waypoint', 'body']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_rep_library_mapping_slots_filter" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'libraryid' is set
        if ('libraryid' not in params or
                params['libraryid'] is None):
            raise ValueError("Missing the required parameter `libraryid` when calling `get_rep_library_mapping_slots_filter`")  # noqa: E501
        # verify the required parameter 'mappingid' is set
        if ('mappingid' not in params or
                params['mappingid'] is None):
            raise ValueError("Missing the required parameter `mappingid` when calling `get_rep_library_mapping_slots_filter`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'libraryid' in params:
            path_params['libraryid'] = params['libraryid']  # noqa: E501
        if 'mappingid' in params:
            path_params['mappingid'] = params['mappingid']  # noqa: E501

        query_params = []
        if 'waypoint' in params:
            query_params.append(('waypoint', params['waypoint']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/rep/library-mapping-slots/library/{libraryid}/mapping/{mappingid}/filter', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='LibraryMappingSlotsCollection',  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_rep_library_mapping_slot(self, libraryid, mappingid, slotid, **kwargs):  # noqa: E501
        """Updates the library slot details  # noqa: E501

        Update the slot details with the given property  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.update_rep_library_mapping_slot(libraryid, mappingid, slotid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str libraryid: Unique id of the library (required)
        :param str mappingid: Unique id of the mapping in the library (required)
        :param str slotid: Unique id of the slot in the mapping (required)
        :param LibraryMappingSlotsPutModel body: Properties of library mapping slot to be updated
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.update_rep_library_mapping_slot_with_http_info(libraryid, mappingid, slotid, **kwargs)  # noqa: E501
        else:
            (data) = self.update_rep_library_mapping_slot_with_http_info(libraryid, mappingid, slotid, **kwargs)  # noqa: E501
            return data

    def update_rep_library_mapping_slot_with_http_info(self, libraryid, mappingid, slotid, **kwargs):  # noqa: E501
        """Updates the library slot details  # noqa: E501

        Update the slot details with the given property  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.update_rep_library_mapping_slot_with_http_info(libraryid, mappingid, slotid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str libraryid: Unique id of the library (required)
        :param str mappingid: Unique id of the mapping in the library (required)
        :param str slotid: Unique id of the slot in the mapping (required)
        :param LibraryMappingSlotsPutModel body: Properties of library mapping slot to be updated
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['libraryid', 'mappingid', 'slotid', 'body']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_rep_library_mapping_slot" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'libraryid' is set
        if ('libraryid' not in params or
                params['libraryid'] is None):
            raise ValueError("Missing the required parameter `libraryid` when calling `update_rep_library_mapping_slot`")  # noqa: E501
        # verify the required parameter 'mappingid' is set
        if ('mappingid' not in params or
                params['mappingid'] is None):
            raise ValueError("Missing the required parameter `mappingid` when calling `update_rep_library_mapping_slot`")  # noqa: E501
        # verify the required parameter 'slotid' is set
        if ('slotid' not in params or
                params['slotid'] is None):
            raise ValueError("Missing the required parameter `slotid` when calling `update_rep_library_mapping_slot`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'libraryid' in params:
            path_params['libraryid'] = params['libraryid']  # noqa: E501
        if 'mappingid' in params:
            path_params['mappingid'] = params['mappingid']  # noqa: E501
        if 'slotid' in params:
            path_params['slotid'] = params['slotid']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/rep/library-mapping-slots/library/{libraryid}/mapping/{mappingid}/slot/{slotid}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
