# coding: utf-8

"""
    (C) Copyright 2018-2019 Hewlett Packard Enterprise Development LP

    Replication

    unused  # noqa: E501

    Component version: 3.3.11-SNAPSHOT
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from ..api_client import ApiClient


class VTLLibraryMappingsApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def create_vtl_library_mapping(self, libraryid, **kwargs):  # noqa: E501
        """Creates a vtl mapping  # noqa: E501

        Creates the vtl mapping with the given properties  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.create_vtl_library_mapping(libraryid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str libraryid: Library ID (required)
        :param VtlLibraryMappingPostModel body: Properties of library mapping
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.create_vtl_library_mapping_with_http_info(libraryid, **kwargs)  # noqa: E501
        else:
            (data) = self.create_vtl_library_mapping_with_http_info(libraryid, **kwargs)  # noqa: E501
            return data

    def create_vtl_library_mapping_with_http_info(self, libraryid, **kwargs):  # noqa: E501
        """Creates a vtl mapping  # noqa: E501

        Creates the vtl mapping with the given properties  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.create_vtl_library_mapping_with_http_info(libraryid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str libraryid: Library ID (required)
        :param VtlLibraryMappingPostModel body: Properties of library mapping
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['libraryid', 'body']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_vtl_library_mapping" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'libraryid' is set
        if ('libraryid' not in params or
                params['libraryid'] is None):
            raise ValueError("Missing the required parameter `libraryid` when calling `create_vtl_library_mapping`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'libraryid' in params:
            path_params['libraryid'] = params['libraryid']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/rep/library-mappings/library/{libraryid}', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_vtl_mapping(self, libraryid, mappingid, **kwargs):  # noqa: E501
        """Delete Vtl Library mapping  # noqa: E501

        Deletes the specified vtl library mapping  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.delete_vtl_mapping(libraryid, mappingid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str libraryid: Library ID (required)
        :param str mappingid: Mapping ID (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.delete_vtl_mapping_with_http_info(libraryid, mappingid, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_vtl_mapping_with_http_info(libraryid, mappingid, **kwargs)  # noqa: E501
            return data

    def delete_vtl_mapping_with_http_info(self, libraryid, mappingid, **kwargs):  # noqa: E501
        """Delete Vtl Library mapping  # noqa: E501

        Deletes the specified vtl library mapping  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.delete_vtl_mapping_with_http_info(libraryid, mappingid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str libraryid: Library ID (required)
        :param str mappingid: Mapping ID (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['libraryid', 'mappingid']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_vtl_mapping" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'libraryid' is set
        if ('libraryid' not in params or
                params['libraryid'] is None):
            raise ValueError("Missing the required parameter `libraryid` when calling `delete_vtl_mapping`")  # noqa: E501
        # verify the required parameter 'mappingid' is set
        if ('mappingid' not in params or
                params['mappingid'] is None):
            raise ValueError("Missing the required parameter `mappingid` when calling `delete_vtl_mapping`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'libraryid' in params:
            path_params['libraryid'] = params['libraryid']  # noqa: E501
        if 'mappingid' in params:
            path_params['mappingid'] = params['mappingid']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/rep/library-mappings/library/{libraryid}/mapping/{mappingid}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_default_vtl_mapping(self, libraryid, body, **kwargs):  # noqa: E501
        """Get default values for a new VTL replication mapping  # noqa: E501

        Operation allows to get default VTL replication mapping on the specified source library  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_default_vtl_mapping(libraryid, body, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str libraryid: Library id (required)
        :param VtlLibraryDefaultMappingModel body: Properties of the VTL replication mapping to create new library mapping (required)
        :return: VtlMappingMappedSlotsCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.get_default_vtl_mapping_with_http_info(libraryid, body, **kwargs)  # noqa: E501
        else:
            (data) = self.get_default_vtl_mapping_with_http_info(libraryid, body, **kwargs)  # noqa: E501
            return data

    def get_default_vtl_mapping_with_http_info(self, libraryid, body, **kwargs):  # noqa: E501
        """Get default values for a new VTL replication mapping  # noqa: E501

        Operation allows to get default VTL replication mapping on the specified source library  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.get_default_vtl_mapping_with_http_info(libraryid, body, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str libraryid: Library id (required)
        :param VtlLibraryDefaultMappingModel body: Properties of the VTL replication mapping to create new library mapping (required)
        :return: VtlMappingMappedSlotsCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['libraryid', 'body']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_default_vtl_mapping" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'libraryid' is set
        if ('libraryid' not in params or
                params['libraryid'] is None):
            raise ValueError("Missing the required parameter `libraryid` when calling `get_default_vtl_mapping`")  # noqa: E501
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `get_default_vtl_mapping`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'libraryid' in params:
            path_params['libraryid'] = params['libraryid']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/rep/library-mappings/library/{libraryid}/defaultMapping', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='VtlMappingMappedSlotsCollection',  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_vtl_library_mapping(self, libraryid, mappingid, **kwargs):  # noqa: E501
        """Get vtl library mapping for the provided mapping id of the library  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_vtl_library_mapping(libraryid, mappingid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str libraryid: Library ID (required)
        :param str mappingid: Mapping ID (required)
        :return: VtlLibraryMappingModel
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.get_vtl_library_mapping_with_http_info(libraryid, mappingid, **kwargs)  # noqa: E501
        else:
            (data) = self.get_vtl_library_mapping_with_http_info(libraryid, mappingid, **kwargs)  # noqa: E501
            return data

    def get_vtl_library_mapping_with_http_info(self, libraryid, mappingid, **kwargs):  # noqa: E501
        """Get vtl library mapping for the provided mapping id of the library  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.get_vtl_library_mapping_with_http_info(libraryid, mappingid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str libraryid: Library ID (required)
        :param str mappingid: Mapping ID (required)
        :return: VtlLibraryMappingModel
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['libraryid', 'mappingid']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_vtl_library_mapping" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'libraryid' is set
        if ('libraryid' not in params or
                params['libraryid'] is None):
            raise ValueError("Missing the required parameter `libraryid` when calling `get_vtl_library_mapping`")  # noqa: E501
        # verify the required parameter 'mappingid' is set
        if ('mappingid' not in params or
                params['mappingid'] is None):
            raise ValueError("Missing the required parameter `mappingid` when calling `get_vtl_library_mapping`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'libraryid' in params:
            path_params['libraryid'] = params['libraryid']  # noqa: E501
        if 'mappingid' in params:
            path_params['mappingid'] = params['mappingid']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/rep/library-mappings/library/{libraryid}/mapping/{mappingid}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='VtlLibraryMappingModel',  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_vtl_library_mappings(self, libraryid, **kwargs):  # noqa: E501
        """Get all the vtl library mappings on the given library  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_vtl_library_mappings(libraryid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str libraryid: Library ID (required)
        :return: VtlLibraryMappingCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.get_vtl_library_mappings_with_http_info(libraryid, **kwargs)  # noqa: E501
        else:
            (data) = self.get_vtl_library_mappings_with_http_info(libraryid, **kwargs)  # noqa: E501
            return data

    def get_vtl_library_mappings_with_http_info(self, libraryid, **kwargs):  # noqa: E501
        """Get all the vtl library mappings on the given library  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.get_vtl_library_mappings_with_http_info(libraryid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str libraryid: Library ID (required)
        :return: VtlLibraryMappingCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['libraryid']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_vtl_library_mappings" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'libraryid' is set
        if ('libraryid' not in params or
                params['libraryid'] is None):
            raise ValueError("Missing the required parameter `libraryid` when calling `get_vtl_library_mappings`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'libraryid' in params:
            path_params['libraryid'] = params['libraryid']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/rep/library-mappings/library/{libraryid}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='VtlLibraryMappingCollection',  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_vtl_library_mappings_all_libraries(self, **kwargs):  # noqa: E501
        """Get all the vtl library mappings on the given library  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_vtl_library_mappings_all_libraries(async_=True)
        >>> result = thread.get()

        :param async_ bool
        :return: VtlLibraryMappingCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.get_vtl_library_mappings_all_libraries_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_vtl_library_mappings_all_libraries_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_vtl_library_mappings_all_libraries_with_http_info(self, **kwargs):  # noqa: E501
        """Get all the vtl library mappings on the given library  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.get_vtl_library_mappings_all_libraries_with_http_info(async_=True)
        >>> result = thread.get()

        :param async_ bool
        :return: VtlLibraryMappingCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = []  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_vtl_library_mappings_all_libraries" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/rep/library-mappings', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='VtlLibraryMappingCollection',  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_vtl_mapping_sync_state_counts(self, **kwargs):  # noqa: E501
        """Get mapping sync status counts  # noqa: E501

        Gets the count of sync status for vtl mappings  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_vtl_mapping_sync_state_counts(async_=True)
        >>> result = thread.get()

        :param async_ bool
        :return: MappingSyncCountsModel
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.get_vtl_mapping_sync_state_counts_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_vtl_mapping_sync_state_counts_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_vtl_mapping_sync_state_counts_with_http_info(self, **kwargs):  # noqa: E501
        """Get mapping sync status counts  # noqa: E501

        Gets the count of sync status for vtl mappings  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.get_vtl_mapping_sync_state_counts_with_http_info(async_=True)
        >>> result = thread.get()

        :param async_ bool
        :return: MappingSyncCountsModel
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = []  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_vtl_mapping_sync_state_counts" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/rep/library-mappings/count', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='MappingSyncCountsModel',  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_vtl_library_mapping(self, libraryid, mappingid, **kwargs):  # noqa: E501
        """Update a vtl library mapping  # noqa: E501

        Updates the specified vtl library mapping  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.update_vtl_library_mapping(libraryid, mappingid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str libraryid: Library ID (required)
        :param str mappingid: Mapping ID (required)
        :param VtlLibraryMappingPutModel body: Properties of library mapping
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.update_vtl_library_mapping_with_http_info(libraryid, mappingid, **kwargs)  # noqa: E501
        else:
            (data) = self.update_vtl_library_mapping_with_http_info(libraryid, mappingid, **kwargs)  # noqa: E501
            return data

    def update_vtl_library_mapping_with_http_info(self, libraryid, mappingid, **kwargs):  # noqa: E501
        """Update a vtl library mapping  # noqa: E501

        Updates the specified vtl library mapping  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.update_vtl_library_mapping_with_http_info(libraryid, mappingid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str libraryid: Library ID (required)
        :param str mappingid: Mapping ID (required)
        :param VtlLibraryMappingPutModel body: Properties of library mapping
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['libraryid', 'mappingid', 'body']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_vtl_library_mapping" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'libraryid' is set
        if ('libraryid' not in params or
                params['libraryid'] is None):
            raise ValueError("Missing the required parameter `libraryid` when calling `update_vtl_library_mapping`")  # noqa: E501
        # verify the required parameter 'mappingid' is set
        if ('mappingid' not in params or
                params['mappingid'] is None):
            raise ValueError("Missing the required parameter `mappingid` when calling `update_vtl_library_mapping`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'libraryid' in params:
            path_params['libraryid'] = params['libraryid']  # noqa: E501
        if 'mappingid' in params:
            path_params['mappingid'] = params['mappingid']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/rep/library-mappings/library/{libraryid}/mapping/{mappingid}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
