# coding: utf-8

"""
    (C) Copyright 2018-2019 Hewlett Packard Enterprise Development LP

    VTL

    unused  # noqa: E501

    Component version: 3.1.8-SNAPSHOT
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from ..api_client import ApiClient


class CartridgeApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def create_vtl_cartridge(self, libraryid, body, **kwargs):  # noqa: E501
        """Create a new Cartridge  # noqa: E501

        Operation used to create a new Cartridge in Library  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.create_vtl_cartridge(libraryid, body, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str libraryid: Library ID (required)
        :param CreateVtlCartridge body: Properties used to create new Cartridge in Library (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.create_vtl_cartridge_with_http_info(libraryid, body, **kwargs)  # noqa: E501
        else:
            (data) = self.create_vtl_cartridge_with_http_info(libraryid, body, **kwargs)  # noqa: E501
            return data

    def create_vtl_cartridge_with_http_info(self, libraryid, body, **kwargs):  # noqa: E501
        """Create a new Cartridge  # noqa: E501

        Operation used to create a new Cartridge in Library  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.create_vtl_cartridge_with_http_info(libraryid, body, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str libraryid: Library ID (required)
        :param CreateVtlCartridge body: Properties used to create new Cartridge in Library (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['libraryid', 'body']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_vtl_cartridge" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'libraryid' is set
        if ('libraryid' not in params or
                params['libraryid'] is None):
            raise ValueError("Missing the required parameter `libraryid` when calling `create_vtl_cartridge`")  # noqa: E501
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `create_vtl_cartridge`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'libraryid' in params:
            path_params['libraryid'] = params['libraryid']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/data-services/vtl/cartridges/library/{libraryid}', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_vtl_cartridge(self, libraryid, cartridge_id, **kwargs):  # noqa: E501
        """Deletes a VTL Cartridge by given ID  # noqa: E501

        Operation used to delete a VTL Cartridge by given Cartridge ID  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.delete_vtl_cartridge(libraryid, cartridge_id, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str libraryid: Library ID (required)
        :param str cartridge_id: Cartridge ID (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.delete_vtl_cartridge_with_http_info(libraryid, cartridge_id, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_vtl_cartridge_with_http_info(libraryid, cartridge_id, **kwargs)  # noqa: E501
            return data

    def delete_vtl_cartridge_with_http_info(self, libraryid, cartridge_id, **kwargs):  # noqa: E501
        """Deletes a VTL Cartridge by given ID  # noqa: E501

        Operation used to delete a VTL Cartridge by given Cartridge ID  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.delete_vtl_cartridge_with_http_info(libraryid, cartridge_id, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str libraryid: Library ID (required)
        :param str cartridge_id: Cartridge ID (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['libraryid', 'cartridge_id']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_vtl_cartridge" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'libraryid' is set
        if ('libraryid' not in params or
                params['libraryid'] is None):
            raise ValueError("Missing the required parameter `libraryid` when calling `delete_vtl_cartridge`")  # noqa: E501
        # verify the required parameter 'cartridge_id' is set
        if ('cartridge_id' not in params or
                params['cartridge_id'] is None):
            raise ValueError("Missing the required parameter `cartridge_id` when calling `delete_vtl_cartridge`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'libraryid' in params:
            path_params['libraryid'] = params['libraryid']  # noqa: E501
        if 'cartridge_id' in params:
            path_params['cartridgeId'] = params['cartridge_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/data-services/vtl/cartridges/library/{libraryid}/cartridge/{cartridgeId}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_vtl_cartridge(self, libraryid, cartridge_id, **kwargs):  # noqa: E501
        """Get Single Cartridge for Library  # noqa: E501

        Provides the status and key properties of a single cartridge for a specified library  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_vtl_cartridge(libraryid, cartridge_id, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str libraryid: Library ID (required)
        :param str cartridge_id: Cartridge ID (required)
        :return: Cartridge
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.get_vtl_cartridge_with_http_info(libraryid, cartridge_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_vtl_cartridge_with_http_info(libraryid, cartridge_id, **kwargs)  # noqa: E501
            return data

    def get_vtl_cartridge_with_http_info(self, libraryid, cartridge_id, **kwargs):  # noqa: E501
        """Get Single Cartridge for Library  # noqa: E501

        Provides the status and key properties of a single cartridge for a specified library  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.get_vtl_cartridge_with_http_info(libraryid, cartridge_id, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str libraryid: Library ID (required)
        :param str cartridge_id: Cartridge ID (required)
        :return: Cartridge
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['libraryid', 'cartridge_id']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_vtl_cartridge" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'libraryid' is set
        if ('libraryid' not in params or
                params['libraryid'] is None):
            raise ValueError("Missing the required parameter `libraryid` when calling `get_vtl_cartridge`")  # noqa: E501
        # verify the required parameter 'cartridge_id' is set
        if ('cartridge_id' not in params or
                params['cartridge_id'] is None):
            raise ValueError("Missing the required parameter `cartridge_id` when calling `get_vtl_cartridge`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'libraryid' in params:
            path_params['libraryid'] = params['libraryid']  # noqa: E501
        if 'cartridge_id' in params:
            path_params['cartridgeId'] = params['cartridge_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/data-services/vtl/cartridges/library/{libraryid}/cartridge/{cartridgeId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Cartridge',  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_vtl_cartridges(self, libraryid, **kwargs):  # noqa: E501
        """Get All Cartridges for Library  # noqa: E501

        Provides the status and key properties of all cartridges for a specified library  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_vtl_cartridges(libraryid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str libraryid: Library ID (required)
        :param str start: Number of members in the collection to skip before returning
        :param str count: Number of members in the collection to skip before returning
        :return: CartridgeGetModelCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.get_vtl_cartridges_with_http_info(libraryid, **kwargs)  # noqa: E501
        else:
            (data) = self.get_vtl_cartridges_with_http_info(libraryid, **kwargs)  # noqa: E501
            return data

    def get_vtl_cartridges_with_http_info(self, libraryid, **kwargs):  # noqa: E501
        """Get All Cartridges for Library  # noqa: E501

        Provides the status and key properties of all cartridges for a specified library  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.get_vtl_cartridges_with_http_info(libraryid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str libraryid: Library ID (required)
        :param str start: Number of members in the collection to skip before returning
        :param str count: Number of members in the collection to skip before returning
        :return: CartridgeGetModelCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['libraryid', 'start', 'count']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_vtl_cartridges" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'libraryid' is set
        if ('libraryid' not in params or
                params['libraryid'] is None):
            raise ValueError("Missing the required parameter `libraryid` when calling `get_vtl_cartridges`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'libraryid' in params:
            path_params['libraryid'] = params['libraryid']  # noqa: E501

        query_params = []
        if 'start' in params:
            query_params.append(('start', params['start']))  # noqa: E501
        if 'count' in params:
            query_params.append(('count', params['count']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/data-services/vtl/cartridges/library/{libraryid}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='CartridgeGetModelCollection',  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_vtl_cartridge(self, libraryid, cartridge_id, body, **kwargs):  # noqa: E501
        """Modifies / Moves / Erase single Cartridge  # noqa: E501

        Operation used to modify / move / erase single Cartridge by given cartridge ID  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.update_vtl_cartridge(libraryid, cartridge_id, body, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str libraryid: Library ID (required)
        :param str cartridge_id: Cartridge ID (required)
        :param ModifyVtlCartridge body: Properties used to modify / move / erase a VTL Cartridge in library (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.update_vtl_cartridge_with_http_info(libraryid, cartridge_id, body, **kwargs)  # noqa: E501
        else:
            (data) = self.update_vtl_cartridge_with_http_info(libraryid, cartridge_id, body, **kwargs)  # noqa: E501
            return data

    def update_vtl_cartridge_with_http_info(self, libraryid, cartridge_id, body, **kwargs):  # noqa: E501
        """Modifies / Moves / Erase single Cartridge  # noqa: E501

        Operation used to modify / move / erase single Cartridge by given cartridge ID  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.update_vtl_cartridge_with_http_info(libraryid, cartridge_id, body, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str libraryid: Library ID (required)
        :param str cartridge_id: Cartridge ID (required)
        :param ModifyVtlCartridge body: Properties used to modify / move / erase a VTL Cartridge in library (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['libraryid', 'cartridge_id', 'body']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_vtl_cartridge" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'libraryid' is set
        if ('libraryid' not in params or
                params['libraryid'] is None):
            raise ValueError("Missing the required parameter `libraryid` when calling `update_vtl_cartridge`")  # noqa: E501
        # verify the required parameter 'cartridge_id' is set
        if ('cartridge_id' not in params or
                params['cartridge_id'] is None):
            raise ValueError("Missing the required parameter `cartridge_id` when calling `update_vtl_cartridge`")  # noqa: E501
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `update_vtl_cartridge`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'libraryid' in params:
            path_params['libraryid'] = params['libraryid']  # noqa: E501
        if 'cartridge_id' in params:
            path_params['cartridgeId'] = params['cartridge_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/data-services/vtl/cartridges/library/{libraryid}/cartridge/{cartridgeId}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
