# coding: utf-8

"""
    (C) Copyright 2018-2019 Hewlett Packard Enterprise Development LP

    VTL

    unused  # noqa: E501

    Component version: 3.1.8-SNAPSHOT
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from ..api_client import ApiClient


class DriveApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_vtl_drive(self, libraryid, driveid, **kwargs):  # noqa: E501
        """Get Single Drive for Library  # noqa: E501

        Provides the status and key properties of a single drive for a specified library  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_vtl_drive(libraryid, driveid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str libraryid: Library ID (required)
        :param str driveid: Drive ID (required)
        :return: Drive
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.get_vtl_drive_with_http_info(libraryid, driveid, **kwargs)  # noqa: E501
        else:
            (data) = self.get_vtl_drive_with_http_info(libraryid, driveid, **kwargs)  # noqa: E501
            return data

    def get_vtl_drive_with_http_info(self, libraryid, driveid, **kwargs):  # noqa: E501
        """Get Single Drive for Library  # noqa: E501

        Provides the status and key properties of a single drive for a specified library  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.get_vtl_drive_with_http_info(libraryid, driveid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str libraryid: Library ID (required)
        :param str driveid: Drive ID (required)
        :return: Drive
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['libraryid', 'driveid']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_vtl_drive" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'libraryid' is set
        if ('libraryid' not in params or
                params['libraryid'] is None):
            raise ValueError("Missing the required parameter `libraryid` when calling `get_vtl_drive`")  # noqa: E501
        # verify the required parameter 'driveid' is set
        if ('driveid' not in params or
                params['driveid'] is None):
            raise ValueError("Missing the required parameter `driveid` when calling `get_vtl_drive`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'libraryid' in params:
            path_params['libraryid'] = params['libraryid']  # noqa: E501
        if 'driveid' in params:
            path_params['driveid'] = params['driveid']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/data-services/vtl/drives/library/{libraryid}/drive/{driveid}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Drive',  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_vtl_drives(self, libraryid, **kwargs):  # noqa: E501
        """Get All Drives for Library  # noqa: E501

        Provides the status and key properties of all drives for a specified library  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_vtl_drives(libraryid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str libraryid: Library ID (required)
        :param str start: Number of members in the collection to skip before returning
        :param str count: Number of members in the collection to skip before returning
        :return: DriveGetModelCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.get_vtl_drives_with_http_info(libraryid, **kwargs)  # noqa: E501
        else:
            (data) = self.get_vtl_drives_with_http_info(libraryid, **kwargs)  # noqa: E501
            return data

    def get_vtl_drives_with_http_info(self, libraryid, **kwargs):  # noqa: E501
        """Get All Drives for Library  # noqa: E501

        Provides the status and key properties of all drives for a specified library  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.get_vtl_drives_with_http_info(libraryid, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str libraryid: Library ID (required)
        :param str start: Number of members in the collection to skip before returning
        :param str count: Number of members in the collection to skip before returning
        :return: DriveGetModelCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['libraryid', 'start', 'count']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_vtl_drives" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'libraryid' is set
        if ('libraryid' not in params or
                params['libraryid'] is None):
            raise ValueError("Missing the required parameter `libraryid` when calling `get_vtl_drives`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'libraryid' in params:
            path_params['libraryid'] = params['libraryid']  # noqa: E501

        query_params = []
        if 'start' in params:
            query_params.append(('start', params['start']))  # noqa: E501
        if 'count' in params:
            query_params.append(('count', params['count']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/data-services/vtl/drives/library/{libraryid}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='DriveGetModelCollection',  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_vtl_drive(self, libraryid, driveid, body, **kwargs):  # noqa: E501
        """Modifies Properties of a Drive  # noqa: E501

        Operation used to modify a drive. Only drives in Fibre channel libraries can be modified  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.update_vtl_drive(libraryid, driveid, body, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str libraryid: Library ID (required)
        :param str driveid: Drive ID (required)
        :param ModifyVtlDrive body: Properties used to modify a VTL Drive in library (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_'):
            return self.update_vtl_drive_with_http_info(libraryid, driveid, body, **kwargs)  # noqa: E501
        else:
            (data) = self.update_vtl_drive_with_http_info(libraryid, driveid, body, **kwargs)  # noqa: E501
            return data

    def update_vtl_drive_with_http_info(self, libraryid, driveid, body, **kwargs):  # noqa: E501
        """Modifies Properties of a Drive  # noqa: E501

        Operation used to modify a drive. Only drives in Fibre channel libraries can be modified  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_=True
        >>> thread = api.update_vtl_drive_with_http_info(libraryid, driveid, body, async_=True)
        >>> result = thread.get()

        :param async_ bool
        :param str libraryid: Library ID (required)
        :param str driveid: Drive ID (required)
        :param ModifyVtlDrive body: Properties used to modify a VTL Drive in library (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['libraryid', 'driveid', 'body']  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_vtl_drive" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'libraryid' is set
        if ('libraryid' not in params or
                params['libraryid'] is None):
            raise ValueError("Missing the required parameter `libraryid` when calling `update_vtl_drive`")  # noqa: E501
        # verify the required parameter 'driveid' is set
        if ('driveid' not in params or
                params['driveid'] is None):
            raise ValueError("Missing the required parameter `driveid` when calling `update_vtl_drive`")  # noqa: E501
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `update_vtl_drive`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'libraryid' in params:
            path_params['libraryid'] = params['libraryid']  # noqa: E501
        if 'driveid' in params:
            path_params['driveid'] = params['driveid']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/data-services/vtl/drives/library/{libraryid}/drive/{driveid}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
