# coding: utf-8

"""
    (C) Copyright 2018-2019 Hewlett Packard Enterprise Development LP

    VTL

    unused  # noqa: E501

    Component version: 3.1.8-SNAPSHOT
"""


import pprint
import re  # noqa: F401

import six


class Cartridge(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'int',
        'barcode': 'str',
        'slot_id': 'int',
        'mail_slot_id': 'int',
        'drive_id': 'int',
        'location_string': 'L10nStringStruct',
        'cartridge_size_bytes': 'int',
        'used_bytes': 'int',
        'write_protection_enabled': 'bool',
        'replication_mapped': 'bool',
        'owner_alias': 'L10nStringStruct',
        'cartridge_written': 'bool',
        'owner_alias_id': 'int',
        'last_written_date': 'datetime'
    }

    attribute_map = {
        'id': 'id',
        'barcode': 'barcode',
        'slot_id': 'slotId',
        'mail_slot_id': 'mailSlotId',
        'drive_id': 'driveId',
        'location_string': 'locationString',
        'cartridge_size_bytes': 'cartridgeSizeBytes',
        'used_bytes': 'usedBytes',
        'write_protection_enabled': 'writeProtectionEnabled',
        'replication_mapped': 'replicationMapped',
        'owner_alias': 'ownerAlias',
        'cartridge_written': 'cartridgeWritten',
        'owner_alias_id': 'ownerAliasId',
        'last_written_date': 'lastWrittenDate'
    }

    def __init__(self, id=None, barcode=None, slot_id=None, mail_slot_id=None, drive_id=None, location_string=None, cartridge_size_bytes=None, used_bytes=None, write_protection_enabled=False, replication_mapped=False, owner_alias=None, cartridge_written=False, owner_alias_id=None, last_written_date=None):  # noqa: E501
        """Cartridge - a model defined in Swagger"""  # noqa: E501

        self._id = None
        self._barcode = None
        self._slot_id = None
        self._mail_slot_id = None
        self._drive_id = None
        self._location_string = None
        self._cartridge_size_bytes = None
        self._used_bytes = None
        self._write_protection_enabled = None
        self._replication_mapped = None
        self._owner_alias = None
        self._cartridge_written = None
        self._owner_alias_id = None
        self._last_written_date = None
        self.discriminator = None

        if id is not None:
            self.id = id
        if barcode is not None:
            self.barcode = barcode
        if slot_id is not None:
            self.slot_id = slot_id
        if mail_slot_id is not None:
            self.mail_slot_id = mail_slot_id
        if drive_id is not None:
            self.drive_id = drive_id
        if location_string is not None:
            self.location_string = location_string
        if cartridge_size_bytes is not None:
            self.cartridge_size_bytes = cartridge_size_bytes
        if used_bytes is not None:
            self.used_bytes = used_bytes
        if write_protection_enabled is not None:
            self.write_protection_enabled = write_protection_enabled
        if replication_mapped is not None:
            self.replication_mapped = replication_mapped
        if owner_alias is not None:
            self.owner_alias = owner_alias
        if cartridge_written is not None:
            self.cartridge_written = cartridge_written
        if owner_alias_id is not None:
            self.owner_alias_id = owner_alias_id
        if last_written_date is not None:
            self.last_written_date = last_written_date

    @property
    def id(self):
        """Gets the id of this Cartridge.  # noqa: E501

        The Cartridge ID which this object corresponds to  # noqa: E501

        :return: The id of this Cartridge.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Cartridge.

        The Cartridge ID which this object corresponds to  # noqa: E501

        :param id: The id of this Cartridge.  # noqa: E501
        :type: int
        """

        self._id = id

    @property
    def barcode(self):
        """Gets the barcode of this Cartridge.  # noqa: E501

        8 character alphanumeric barcode used for the cartridge  # noqa: E501

        :return: The barcode of this Cartridge.  # noqa: E501
        :rtype: str
        """
        return self._barcode

    @barcode.setter
    def barcode(self, barcode):
        """Sets the barcode of this Cartridge.

        8 character alphanumeric barcode used for the cartridge  # noqa: E501

        :param barcode: The barcode of this Cartridge.  # noqa: E501
        :type: str
        """

        self._barcode = barcode

    @property
    def slot_id(self):
        """Gets the slot_id of this Cartridge.  # noqa: E501

        ID of the Slot the cartridge is currently located in. Valid only if cartridge is located in a slot.  # noqa: E501

        :return: The slot_id of this Cartridge.  # noqa: E501
        :rtype: int
        """
        return self._slot_id

    @slot_id.setter
    def slot_id(self, slot_id):
        """Sets the slot_id of this Cartridge.

        ID of the Slot the cartridge is currently located in. Valid only if cartridge is located in a slot.  # noqa: E501

        :param slot_id: The slot_id of this Cartridge.  # noqa: E501
        :type: int
        """

        self._slot_id = slot_id

    @property
    def mail_slot_id(self):
        """Gets the mail_slot_id of this Cartridge.  # noqa: E501

        ID of the Mail Slot the cartridge is currently located in. Valid only if cartridge is located in a mail slot.  # noqa: E501

        :return: The mail_slot_id of this Cartridge.  # noqa: E501
        :rtype: int
        """
        return self._mail_slot_id

    @mail_slot_id.setter
    def mail_slot_id(self, mail_slot_id):
        """Sets the mail_slot_id of this Cartridge.

        ID of the Mail Slot the cartridge is currently located in. Valid only if cartridge is located in a mail slot.  # noqa: E501

        :param mail_slot_id: The mail_slot_id of this Cartridge.  # noqa: E501
        :type: int
        """

        self._mail_slot_id = mail_slot_id

    @property
    def drive_id(self):
        """Gets the drive_id of this Cartridge.  # noqa: E501

        ID of the Drive the cartridge is currently located in. Valid only if cartridge is located in a drive  # noqa: E501

        :return: The drive_id of this Cartridge.  # noqa: E501
        :rtype: int
        """
        return self._drive_id

    @drive_id.setter
    def drive_id(self, drive_id):
        """Sets the drive_id of this Cartridge.

        ID of the Drive the cartridge is currently located in. Valid only if cartridge is located in a drive  # noqa: E501

        :param drive_id: The drive_id of this Cartridge.  # noqa: E501
        :type: int
        """

        self._drive_id = drive_id

    @property
    def location_string(self):
        """Gets the location_string of this Cartridge.  # noqa: E501

        Localised string representing the location of the cartridge in the library  # noqa: E501

        :return: The location_string of this Cartridge.  # noqa: E501
        :rtype: L10nStringStruct
        """
        return self._location_string

    @location_string.setter
    def location_string(self, location_string):
        """Sets the location_string of this Cartridge.

        Localised string representing the location of the cartridge in the library  # noqa: E501

        :param location_string: The location_string of this Cartridge.  # noqa: E501
        :type: L10nStringStruct
        """

        self._location_string = location_string

    @property
    def cartridge_size_bytes(self):
        """Gets the cartridge_size_bytes of this Cartridge.  # noqa: E501

        Maximum amount of data that can be stored in the cartridge, in bytes  # noqa: E501

        :return: The cartridge_size_bytes of this Cartridge.  # noqa: E501
        :rtype: int
        """
        return self._cartridge_size_bytes

    @cartridge_size_bytes.setter
    def cartridge_size_bytes(self, cartridge_size_bytes):
        """Sets the cartridge_size_bytes of this Cartridge.

        Maximum amount of data that can be stored in the cartridge, in bytes  # noqa: E501

        :param cartridge_size_bytes: The cartridge_size_bytes of this Cartridge.  # noqa: E501
        :type: int
        """

        self._cartridge_size_bytes = cartridge_size_bytes

    @property
    def used_bytes(self):
        """Gets the used_bytes of this Cartridge.  # noqa: E501

        Size of the current data on the cartridge in bytes  # noqa: E501

        :return: The used_bytes of this Cartridge.  # noqa: E501
        :rtype: int
        """
        return self._used_bytes

    @used_bytes.setter
    def used_bytes(self, used_bytes):
        """Sets the used_bytes of this Cartridge.

        Size of the current data on the cartridge in bytes  # noqa: E501

        :param used_bytes: The used_bytes of this Cartridge.  # noqa: E501
        :type: int
        """

        self._used_bytes = used_bytes

    @property
    def write_protection_enabled(self):
        """Gets the write_protection_enabled of this Cartridge.  # noqa: E501

        Flag true or false decides cartridge is write protected  # noqa: E501

        :return: The write_protection_enabled of this Cartridge.  # noqa: E501
        :rtype: bool
        """
        return self._write_protection_enabled

    @write_protection_enabled.setter
    def write_protection_enabled(self, write_protection_enabled):
        """Sets the write_protection_enabled of this Cartridge.

        Flag true or false decides cartridge is write protected  # noqa: E501

        :param write_protection_enabled: The write_protection_enabled of this Cartridge.  # noqa: E501
        :type: bool
        """

        self._write_protection_enabled = write_protection_enabled

    @property
    def replication_mapped(self):
        """Gets the replication_mapped of this Cartridge.  # noqa: E501

        Flag true or false decides cartridge is in a replication mapping  # noqa: E501

        :return: The replication_mapped of this Cartridge.  # noqa: E501
        :rtype: bool
        """
        return self._replication_mapped

    @replication_mapped.setter
    def replication_mapped(self, replication_mapped):
        """Sets the replication_mapped of this Cartridge.

        Flag true or false decides cartridge is in a replication mapping  # noqa: E501

        :param replication_mapped: The replication_mapped of this Cartridge.  # noqa: E501
        :type: bool
        """

        self._replication_mapped = replication_mapped

    @property
    def owner_alias(self):
        """Gets the owner_alias of this Cartridge.  # noqa: E501

        Localized string representing the slot that this cartridge was recently removed from home slot). This value is only available if the cartridge current location is a drive or mail slot  # noqa: E501

        :return: The owner_alias of this Cartridge.  # noqa: E501
        :rtype: L10nStringStruct
        """
        return self._owner_alias

    @owner_alias.setter
    def owner_alias(self, owner_alias):
        """Sets the owner_alias of this Cartridge.

        Localized string representing the slot that this cartridge was recently removed from home slot). This value is only available if the cartridge current location is a drive or mail slot  # noqa: E501

        :param owner_alias: The owner_alias of this Cartridge.  # noqa: E501
        :type: L10nStringStruct
        """

        self._owner_alias = owner_alias

    @property
    def cartridge_written(self):
        """Gets the cartridge_written of this Cartridge.  # noqa: E501

        Flag true or false decides cartridge was previously written  # noqa: E501

        :return: The cartridge_written of this Cartridge.  # noqa: E501
        :rtype: bool
        """
        return self._cartridge_written

    @cartridge_written.setter
    def cartridge_written(self, cartridge_written):
        """Sets the cartridge_written of this Cartridge.

        Flag true or false decides cartridge was previously written  # noqa: E501

        :param cartridge_written: The cartridge_written of this Cartridge.  # noqa: E501
        :type: bool
        """

        self._cartridge_written = cartridge_written

    @property
    def owner_alias_id(self):
        """Gets the owner_alias_id of this Cartridge.  # noqa: E501

        ID of the slot that this cartridge was moved from its home slot. This value is only available if the cartridge current location is a drive or mail slot  # noqa: E501

        :return: The owner_alias_id of this Cartridge.  # noqa: E501
        :rtype: int
        """
        return self._owner_alias_id

    @owner_alias_id.setter
    def owner_alias_id(self, owner_alias_id):
        """Sets the owner_alias_id of this Cartridge.

        ID of the slot that this cartridge was moved from its home slot. This value is only available if the cartridge current location is a drive or mail slot  # noqa: E501

        :param owner_alias_id: The owner_alias_id of this Cartridge.  # noqa: E501
        :type: int
        """

        self._owner_alias_id = owner_alias_id

    @property
    def last_written_date(self):
        """Gets the last_written_date of this Cartridge.  # noqa: E501

        Time this cartridge was last written to. Defined only if the cartridge has been previously written to.  # noqa: E501

        :return: The last_written_date of this Cartridge.  # noqa: E501
        :rtype: datetime
        """
        return self._last_written_date

    @last_written_date.setter
    def last_written_date(self, last_written_date):
        """Sets the last_written_date of this Cartridge.

        Time this cartridge was last written to. Defined only if the cartridge has been previously written to.  # noqa: E501

        :param last_written_date: The last_written_date of this Cartridge.  # noqa: E501
        :type: datetime
        """

        self._last_written_date = last_written_date

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Cartridge, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Cartridge):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
