# coding: utf-8

"""
    (C) Copyright 2018-2019 Hewlett Packard Enterprise Development LP

    VTL

    unused  # noqa: E501

    Component version: 3.1.8-SNAPSHOT
"""


import pprint
import re  # noqa: F401

import six


class FibreChannelProperties(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'port_id': 'int',
        'port_id_string': 'L10nStringStruct',
        'port_name': 'str',
        'node_name': 'str',
        'fcid': 'str',
        'num_logins': 'int'
    }

    attribute_map = {
        'port_id': 'portId',
        'port_id_string': 'portIdString',
        'port_name': 'portName',
        'node_name': 'nodeName',
        'fcid': 'fcid',
        'num_logins': 'numLogins'
    }

    def __init__(self, port_id=None, port_id_string=None, port_name=None, node_name=None, fcid=None, num_logins=None):  # noqa: E501
        """FibreChannelProperties - a model defined in Swagger"""  # noqa: E501

        self._port_id = None
        self._port_id_string = None
        self._port_name = None
        self._node_name = None
        self._fcid = None
        self._num_logins = None
        self.discriminator = None

        if port_id is not None:
            self.port_id = port_id
        if port_id_string is not None:
            self.port_id_string = port_id_string
        if port_name is not None:
            self.port_name = port_name
        if node_name is not None:
            self.node_name = node_name
        if fcid is not None:
            self.fcid = fcid
        if num_logins is not None:
            self.num_logins = num_logins

    @property
    def port_id(self):
        """Gets the port_id of this FibreChannelProperties.  # noqa: E501

        ID of the FC port that the drive is presented on  # noqa: E501

        :return: The port_id of this FibreChannelProperties.  # noqa: E501
        :rtype: int
        """
        return self._port_id

    @port_id.setter
    def port_id(self, port_id):
        """Sets the port_id of this FibreChannelProperties.

        ID of the FC port that the drive is presented on  # noqa: E501

        :param port_id: The port_id of this FibreChannelProperties.  # noqa: E501
        :type: int
        """

        self._port_id = port_id

    @property
    def port_id_string(self):
        """Gets the port_id_string of this FibreChannelProperties.  # noqa: E501

        Localised string representing port id  # noqa: E501

        :return: The port_id_string of this FibreChannelProperties.  # noqa: E501
        :rtype: L10nStringStruct
        """
        return self._port_id_string

    @port_id_string.setter
    def port_id_string(self, port_id_string):
        """Sets the port_id_string of this FibreChannelProperties.

        Localised string representing port id  # noqa: E501

        :param port_id_string: The port_id_string of this FibreChannelProperties.  # noqa: E501
        :type: L10nStringStruct
        """

        self._port_id_string = port_id_string

    @property
    def port_name(self):
        """Gets the port_name of this FibreChannelProperties.  # noqa: E501

        World Wide Port Name for the port the drive is presented on  # noqa: E501

        :return: The port_name of this FibreChannelProperties.  # noqa: E501
        :rtype: str
        """
        return self._port_name

    @port_name.setter
    def port_name(self, port_name):
        """Sets the port_name of this FibreChannelProperties.

        World Wide Port Name for the port the drive is presented on  # noqa: E501

        :param port_name: The port_name of this FibreChannelProperties.  # noqa: E501
        :type: str
        """

        self._port_name = port_name

    @property
    def node_name(self):
        """Gets the node_name of this FibreChannelProperties.  # noqa: E501

        The World Wide Node Name for the drive  # noqa: E501

        :return: The node_name of this FibreChannelProperties.  # noqa: E501
        :rtype: str
        """
        return self._node_name

    @node_name.setter
    def node_name(self, node_name):
        """Sets the node_name of this FibreChannelProperties.

        The World Wide Node Name for the drive  # noqa: E501

        :param node_name: The node_name of this FibreChannelProperties.  # noqa: E501
        :type: str
        """

        self._node_name = node_name

    @property
    def fcid(self):
        """Gets the fcid of this FibreChannelProperties.  # noqa: E501

        Hexadecimal string representing the FCID for this drive. Valid only if the drive is logged in.  # noqa: E501

        :return: The fcid of this FibreChannelProperties.  # noqa: E501
        :rtype: str
        """
        return self._fcid

    @fcid.setter
    def fcid(self, fcid):
        """Sets the fcid of this FibreChannelProperties.

        Hexadecimal string representing the FCID for this drive. Valid only if the drive is logged in.  # noqa: E501

        :param fcid: The fcid of this FibreChannelProperties.  # noqa: E501
        :type: str
        """

        self._fcid = fcid

    @property
    def num_logins(self):
        """Gets the num_logins of this FibreChannelProperties.  # noqa: E501

        Number of logins on this port  # noqa: E501

        :return: The num_logins of this FibreChannelProperties.  # noqa: E501
        :rtype: int
        """
        return self._num_logins

    @num_logins.setter
    def num_logins(self, num_logins):
        """Sets the num_logins of this FibreChannelProperties.

        Number of logins on this port  # noqa: E501

        :param num_logins: The num_logins of this FibreChannelProperties.  # noqa: E501
        :type: int
        """

        self._num_logins = num_logins

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(FibreChannelProperties, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FibreChannelProperties):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
